#ifndef FRAME_CPP_INTERFACE__IFrameStream_HH
#define FRAME_CPP_INTERFACE__IFrameStream_HH

#include "framecpp/FrameCPP.hh"

#if FRAME_SPEC_CURRENT == 3
#include "framecpp/Version3/FrameStream.hh"
#elif FRAME_SPEC_CURRENT == 4
#include "framecpp/Version4/FrameStream.hh"
#elif FRAME_SPEC_CURRENT == 6
#include "framecpp/Version6/FrameStream.hh"
#elif FRAME_SPEC_CURRENT == 7
#include "framecpp/Version7/FrameStream.hh"
#elif FRAME_SPEC_CURRENT == 8
#include "framecpp/Version8/FrameStream.hh"
#else
#error "Unsupported frame spec: FRAME_SPEC_CURRENT"
#endif

namespace FrameCPP
{
  typedef Version::IFrameStream IFrameStream;
}

#endif /* FRAME_CPP_INTERFACE__IFrameStream_HH */
