# generated automatically by aclocal 1.9.6 -*- Autoconf -*-

# Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
# 2005  Free Software Foundation, Inc.
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.

# Copyright (C) 2002, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# AM_AUTOMAKE_VERSION(VERSION)
# ----------------------------
# Automake X.Y traces this macro to ensure aclocal.m4 has been
# generated from the m4 files accompanying Automake X.Y.
AC_DEFUN([AM_AUTOMAKE_VERSION], [am__api_version="1.9"])

# AM_SET_CURRENT_AUTOMAKE_VERSION
# -------------------------------
# Call AM_AUTOMAKE_VERSION so it can be traced.
# This function is AC_REQUIREd by AC_INIT_AUTOMAKE.
AC_DEFUN([AM_SET_CURRENT_AUTOMAKE_VERSION],
	 [AM_AUTOMAKE_VERSION([1.9.6])])

# AM_AUX_DIR_EXPAND                                         -*- Autoconf -*-

# Copyright (C) 2001, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# For projects using AC_CONFIG_AUX_DIR([foo]), Autoconf sets
# $ac_aux_dir to `$srcdir/foo'.  In other projects, it is set to
# `$srcdir', `$srcdir/..', or `$srcdir/../..'.
#
# Of course, Automake must honor this variable whenever it calls a
# tool from the auxiliary directory.  The problem is that $srcdir (and
# therefore $ac_aux_dir as well) can be either absolute or relative,
# depending on how configure is run.  This is pretty annoying, since
# it makes $ac_aux_dir quite unusable in subdirectories: in the top
# source directory, any form will work fine, but in subdirectories a
# relative path needs to be adjusted first.
#
# $ac_aux_dir/missing
#    fails when called from a subdirectory if $ac_aux_dir is relative
# $top_srcdir/$ac_aux_dir/missing
#    fails if $ac_aux_dir is absolute,
#    fails when called from a subdirectory in a VPATH build with
#          a relative $ac_aux_dir
#
# The reason of the latter failure is that $top_srcdir and $ac_aux_dir
# are both prefixed by $srcdir.  In an in-source build this is usually
# harmless because $srcdir is `.', but things will broke when you
# start a VPATH build or use an absolute $srcdir.
#
# So we could use something similar to $top_srcdir/$ac_aux_dir/missing,
# iff we strip the leading $srcdir from $ac_aux_dir.  That would be:
#   am_aux_dir='\$(top_srcdir)/'`expr "$ac_aux_dir" : "$srcdir//*\(.*\)"`
# and then we would define $MISSING as
#   MISSING="\${SHELL} $am_aux_dir/missing"
# This will work as long as MISSING is not called from configure, because
# unfortunately $(top_srcdir) has no meaning in configure.
# However there are other variables, like CC, which are often used in
# configure, and could therefore not use this "fixed" $ac_aux_dir.
#
# Another solution, used here, is to always expand $ac_aux_dir to an
# absolute PATH.  The drawback is that using absolute paths prevent a
# configured tree to be moved without reconfiguration.

AC_DEFUN([AM_AUX_DIR_EXPAND],
[dnl Rely on autoconf to set up CDPATH properly.
AC_PREREQ([2.50])dnl
# expand $ac_aux_dir to an absolute path
am_aux_dir=`cd $ac_aux_dir && pwd`
])

# AM_CONDITIONAL                                            -*- Autoconf -*-

# Copyright (C) 1997, 2000, 2001, 2003, 2004, 2005
# Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 7

# AM_CONDITIONAL(NAME, SHELL-CONDITION)
# -------------------------------------
# Define a conditional.
AC_DEFUN([AM_CONDITIONAL],
[AC_PREREQ(2.52)dnl
 ifelse([$1], [TRUE],  [AC_FATAL([$0: invalid condition: $1])],
	[$1], [FALSE], [AC_FATAL([$0: invalid condition: $1])])dnl
AC_SUBST([$1_TRUE])
AC_SUBST([$1_FALSE])
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi
AC_CONFIG_COMMANDS_PRE(
[if test -z "${$1_TRUE}" && test -z "${$1_FALSE}"; then
  AC_MSG_ERROR([[conditional "$1" was never defined.
Usually this means the macro was only invoked conditionally.]])
fi])])


# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005
# Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 8

# There are a few dirty hacks below to avoid letting `AC_PROG_CC' be
# written in clear, in which case automake, when reading aclocal.m4,
# will think it sees a *use*, and therefore will trigger all it's
# C support machinery.  Also note that it means that autoscan, seeing
# CC etc. in the Makefile, will ask for an AC_PROG_CC use...


# _AM_DEPENDENCIES(NAME)
# ----------------------
# See how the compiler implements dependency checking.
# NAME is "CC", "CXX", "GCJ", or "OBJC".
# We try a few techniques and use that to set a single cache variable.
#
# We don't AC_REQUIRE the corresponding AC_PROG_CC since the latter was
# modified to invoke _AM_DEPENDENCIES(CC); we would have a circular
# dependency, and given that the user is not expected to run this macro,
# just rely on AC_PROG_CC.
AC_DEFUN([_AM_DEPENDENCIES],
[AC_REQUIRE([AM_SET_DEPDIR])dnl
AC_REQUIRE([AM_OUTPUT_DEPENDENCY_COMMANDS])dnl
AC_REQUIRE([AM_MAKE_INCLUDE])dnl
AC_REQUIRE([AM_DEP_TRACK])dnl

ifelse([$1], CC,   [depcc="$CC"   am_compiler_list=],
       [$1], CXX,  [depcc="$CXX"  am_compiler_list=],
       [$1], OBJC, [depcc="$OBJC" am_compiler_list='gcc3 gcc'],
       [$1], GCJ,  [depcc="$GCJ"  am_compiler_list='gcc3 gcc'],
                   [depcc="$$1"   am_compiler_list=])

AC_CACHE_CHECK([dependency style of $depcc],
               [am_cv_$1_dependencies_compiler_type],
[if test -z "$AMDEP_TRUE" && test -f "$am_depcomp"; then
  # We make a subdir and do the tests there.  Otherwise we can end up
  # making bogus files that we don't know about and never remove.  For
  # instance it was reported that on HP-UX the gcc test will end up
  # making a dummy file named `D' -- because `-MD' means `put the output
  # in D'.
  mkdir conftest.dir
  # Copy depcomp to subdir because otherwise we won't find it if we're
  # using a relative directory.
  cp "$am_depcomp" conftest.dir
  cd conftest.dir
  # We will build objects and dependencies in a subdirectory because
  # it helps to detect inapplicable dependency modes.  For instance
  # both Tru64's cc and ICC support -MD to output dependencies as a
  # side effect of compilation, but ICC will put the dependencies in
  # the current directory while Tru64 will put them in the object
  # directory.
  mkdir sub

  am_cv_$1_dependencies_compiler_type=none
  if test "$am_compiler_list" = ""; then
     am_compiler_list=`sed -n ['s/^#*\([a-zA-Z0-9]*\))$/\1/p'] < ./depcomp`
  fi
  for depmode in $am_compiler_list; do
    # Setup a source with many dependencies, because some compilers
    # like to wrap large dependency lists on column 80 (with \), and
    # we should not choose a depcomp mode which is confused by this.
    #
    # We need to recreate these files for each test, as the compiler may
    # overwrite some of them when testing with obscure command lines.
    # This happens at least with the AIX C compiler.
    : > sub/conftest.c
    for i in 1 2 3 4 5 6; do
      echo '#include "conftst'$i'.h"' >> sub/conftest.c
      # Using `: > sub/conftst$i.h' creates only sub/conftst1.h with
      # Solaris 8's {/usr,}/bin/sh.
      touch sub/conftst$i.h
    done
    echo "${am__include} ${am__quote}sub/conftest.Po${am__quote}" > confmf

    case $depmode in
    nosideeffect)
      # after this tag, mechanisms are not by side-effect, so they'll
      # only be used when explicitly requested
      if test "x$enable_dependency_tracking" = xyes; then
	continue
      else
	break
      fi
      ;;
    none) break ;;
    esac
    # We check with `-c' and `-o' for the sake of the "dashmstdout"
    # mode.  It turns out that the SunPro C++ compiler does not properly
    # handle `-M -o', and we need to detect this.
    if depmode=$depmode \
       source=sub/conftest.c object=sub/conftest.${OBJEXT-o} \
       depfile=sub/conftest.Po tmpdepfile=sub/conftest.TPo \
       $SHELL ./depcomp $depcc -c -o sub/conftest.${OBJEXT-o} sub/conftest.c \
         >/dev/null 2>conftest.err &&
       grep sub/conftst6.h sub/conftest.Po > /dev/null 2>&1 &&
       grep sub/conftest.${OBJEXT-o} sub/conftest.Po > /dev/null 2>&1 &&
       ${MAKE-make} -s -f confmf > /dev/null 2>&1; then
      # icc doesn't choke on unknown options, it will just issue warnings
      # or remarks (even with -Werror).  So we grep stderr for any message
      # that says an option was ignored or not supported.
      # When given -MP, icc 7.0 and 7.1 complain thusly:
      #   icc: Command line warning: ignoring option '-M'; no argument required
      # The diagnosis changed in icc 8.0:
      #   icc: Command line remark: option '-MP' not supported
      if (grep 'ignoring option' conftest.err ||
          grep 'not supported' conftest.err) >/dev/null 2>&1; then :; else
        am_cv_$1_dependencies_compiler_type=$depmode
        break
      fi
    fi
  done

  cd ..
  rm -rf conftest.dir
else
  am_cv_$1_dependencies_compiler_type=none
fi
])
AC_SUBST([$1DEPMODE], [depmode=$am_cv_$1_dependencies_compiler_type])
AM_CONDITIONAL([am__fastdep$1], [
  test "x$enable_dependency_tracking" != xno \
  && test "$am_cv_$1_dependencies_compiler_type" = gcc3])
])


# AM_SET_DEPDIR
# -------------
# Choose a directory name for dependency files.
# This macro is AC_REQUIREd in _AM_DEPENDENCIES
AC_DEFUN([AM_SET_DEPDIR],
[AC_REQUIRE([AM_SET_LEADING_DOT])dnl
AC_SUBST([DEPDIR], ["${am__leading_dot}deps"])dnl
])


# AM_DEP_TRACK
# ------------
AC_DEFUN([AM_DEP_TRACK],
[AC_ARG_ENABLE(dependency-tracking,
[  --disable-dependency-tracking  speeds up one-time build
  --enable-dependency-tracking   do not reject slow dependency extractors])
if test "x$enable_dependency_tracking" != xno; then
  am_depcomp="$ac_aux_dir/depcomp"
  AMDEPBACKSLASH='\'
fi
AM_CONDITIONAL([AMDEP], [test "x$enable_dependency_tracking" != xno])
AC_SUBST([AMDEPBACKSLASH])
])

# Generate code to set up dependency tracking.              -*- Autoconf -*-

# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005
# Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

#serial 3

# _AM_OUTPUT_DEPENDENCY_COMMANDS
# ------------------------------
AC_DEFUN([_AM_OUTPUT_DEPENDENCY_COMMANDS],
[for mf in $CONFIG_FILES; do
  # Strip MF so we end up with the name of the file.
  mf=`echo "$mf" | sed -e 's/:.*$//'`
  # Check whether this is an Automake generated Makefile or not.
  # We used to match only the files named `Makefile.in', but
  # some people rename them; so instead we look at the file content.
  # Grep'ing the first line is not enough: some people post-process
  # each Makefile.in and add a new line on top of each file to say so.
  # So let's grep whole file.
  if grep '^#.*generated by automake' $mf > /dev/null 2>&1; then
    dirpart=`AS_DIRNAME("$mf")`
  else
    continue
  fi
  # Extract the definition of DEPDIR, am__include, and am__quote
  # from the Makefile without running `make'.
  DEPDIR=`sed -n 's/^DEPDIR = //p' < "$mf"`
  test -z "$DEPDIR" && continue
  am__include=`sed -n 's/^am__include = //p' < "$mf"`
  test -z "am__include" && continue
  am__quote=`sed -n 's/^am__quote = //p' < "$mf"`
  # When using ansi2knr, U may be empty or an underscore; expand it
  U=`sed -n 's/^U = //p' < "$mf"`
  # Find all dependency output files, they are included files with
  # $(DEPDIR) in their names.  We invoke sed twice because it is the
  # simplest approach to changing $(DEPDIR) to its actual value in the
  # expansion.
  for file in `sed -n "
    s/^$am__include $am__quote\(.*(DEPDIR).*\)$am__quote"'$/\1/p' <"$mf" | \
       sed -e 's/\$(DEPDIR)/'"$DEPDIR"'/g' -e 's/\$U/'"$U"'/g'`; do
    # Make sure the directory exists.
    test -f "$dirpart/$file" && continue
    fdir=`AS_DIRNAME(["$file"])`
    AS_MKDIR_P([$dirpart/$fdir])
    # echo "creating $dirpart/$file"
    echo '# dummy' > "$dirpart/$file"
  done
done
])# _AM_OUTPUT_DEPENDENCY_COMMANDS


# AM_OUTPUT_DEPENDENCY_COMMANDS
# -----------------------------
# This macro should only be invoked once -- use via AC_REQUIRE.
#
# This code is only required when automatic dependency tracking
# is enabled.  FIXME.  This creates each `.P' file that we will
# need in order to bootstrap the dependency handling code.
AC_DEFUN([AM_OUTPUT_DEPENDENCY_COMMANDS],
[AC_CONFIG_COMMANDS([depfiles],
     [test x"$AMDEP_TRUE" != x"" || _AM_OUTPUT_DEPENDENCY_COMMANDS],
     [AMDEP_TRUE="$AMDEP_TRUE" ac_aux_dir="$ac_aux_dir"])
])

# Do all the work for Automake.                             -*- Autoconf -*-

# Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005
# Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 12

# This macro actually does too much.  Some checks are only needed if
# your package does certain things.  But this isn't really a big deal.

# AM_INIT_AUTOMAKE(PACKAGE, VERSION, [NO-DEFINE])
# AM_INIT_AUTOMAKE([OPTIONS])
# -----------------------------------------------
# The call with PACKAGE and VERSION arguments is the old style
# call (pre autoconf-2.50), which is being phased out.  PACKAGE
# and VERSION should now be passed to AC_INIT and removed from
# the call to AM_INIT_AUTOMAKE.
# We support both call styles for the transition.  After
# the next Automake release, Autoconf can make the AC_INIT
# arguments mandatory, and then we can depend on a new Autoconf
# release and drop the old call support.
AC_DEFUN([AM_INIT_AUTOMAKE],
[AC_PREREQ([2.58])dnl
dnl Autoconf wants to disallow AM_ names.  We explicitly allow
dnl the ones we care about.
m4_pattern_allow([^AM_[A-Z]+FLAGS$])dnl
AC_REQUIRE([AM_SET_CURRENT_AUTOMAKE_VERSION])dnl
AC_REQUIRE([AC_PROG_INSTALL])dnl
# test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" &&
   test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi

# test whether we have cygpath
if test -z "$CYGPATH_W"; then
  if (cygpath --version) >/dev/null 2>/dev/null; then
    CYGPATH_W='cygpath -w'
  else
    CYGPATH_W=echo
  fi
fi
AC_SUBST([CYGPATH_W])

# Define the identity of the package.
dnl Distinguish between old-style and new-style calls.
m4_ifval([$2],
[m4_ifval([$3], [_AM_SET_OPTION([no-define])])dnl
 AC_SUBST([PACKAGE], [$1])dnl
 AC_SUBST([VERSION], [$2])],
[_AM_SET_OPTIONS([$1])dnl
 AC_SUBST([PACKAGE], ['AC_PACKAGE_TARNAME'])dnl
 AC_SUBST([VERSION], ['AC_PACKAGE_VERSION'])])dnl

_AM_IF_OPTION([no-define],,
[AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
 AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package])])dnl

# Some tools Automake needs.
AC_REQUIRE([AM_SANITY_CHECK])dnl
AC_REQUIRE([AC_ARG_PROGRAM])dnl
AM_MISSING_PROG(ACLOCAL, aclocal-${am__api_version})
AM_MISSING_PROG(AUTOCONF, autoconf)
AM_MISSING_PROG(AUTOMAKE, automake-${am__api_version})
AM_MISSING_PROG(AUTOHEADER, autoheader)
AM_MISSING_PROG(MAKEINFO, makeinfo)
AM_PROG_INSTALL_SH
AM_PROG_INSTALL_STRIP
AC_REQUIRE([AM_PROG_MKDIR_P])dnl
# We need awk for the "check" target.  The system "awk" is bad on
# some platforms.
AC_REQUIRE([AC_PROG_AWK])dnl
AC_REQUIRE([AC_PROG_MAKE_SET])dnl
AC_REQUIRE([AM_SET_LEADING_DOT])dnl
_AM_IF_OPTION([tar-ustar], [_AM_PROG_TAR([ustar])],
              [_AM_IF_OPTION([tar-pax], [_AM_PROG_TAR([pax])],
	      		     [_AM_PROG_TAR([v7])])])
_AM_IF_OPTION([no-dependencies],,
[AC_PROVIDE_IFELSE([AC_PROG_CC],
                  [_AM_DEPENDENCIES(CC)],
                  [define([AC_PROG_CC],
                          defn([AC_PROG_CC])[_AM_DEPENDENCIES(CC)])])dnl
AC_PROVIDE_IFELSE([AC_PROG_CXX],
                  [_AM_DEPENDENCIES(CXX)],
                  [define([AC_PROG_CXX],
                          defn([AC_PROG_CXX])[_AM_DEPENDENCIES(CXX)])])dnl
])
])


# When config.status generates a header, we must update the stamp-h file.
# This file resides in the same directory as the config header
# that is generated.  The stamp files are numbered to have different names.

# Autoconf calls _AC_AM_CONFIG_HEADER_HOOK (when defined) in the
# loop where config.status creates the headers, so we can generate
# our stamp files there.
AC_DEFUN([_AC_AM_CONFIG_HEADER_HOOK],
[# Compute $1's index in $config_headers.
_am_stamp_count=1
for _am_header in $config_headers :; do
  case $_am_header in
    $1 | $1:* )
      break ;;
    * )
      _am_stamp_count=`expr $_am_stamp_count + 1` ;;
  esac
done
echo "timestamp for $1" >`AS_DIRNAME([$1])`/stamp-h[]$_am_stamp_count])

# Copyright (C) 2001, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# AM_PROG_INSTALL_SH
# ------------------
# Define $install_sh.
AC_DEFUN([AM_PROG_INSTALL_SH],
[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
install_sh=${install_sh-"$am_aux_dir/install-sh"}
AC_SUBST(install_sh)])

# Copyright (C) 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 2

# Check whether the underlying file-system supports filenames
# with a leading dot.  For instance MS-DOS doesn't.
AC_DEFUN([AM_SET_LEADING_DOT],
[rm -rf .tst 2>/dev/null
mkdir .tst 2>/dev/null
if test -d .tst; then
  am__leading_dot=.
else
  am__leading_dot=_
fi
rmdir .tst 2>/dev/null
AC_SUBST([am__leading_dot])])

# Check to see how 'make' treats includes.	            -*- Autoconf -*-

# Copyright (C) 2001, 2002, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 3

# AM_MAKE_INCLUDE()
# -----------------
# Check to see how make treats includes.
AC_DEFUN([AM_MAKE_INCLUDE],
[am_make=${MAKE-make}
cat > confinc << 'END'
am__doit:
	@echo done
.PHONY: am__doit
END
# If we don't find an include directive, just comment out the code.
AC_MSG_CHECKING([for style of include used by $am_make])
am__include="#"
am__quote=
_am_result=none
# First try GNU make style include.
echo "include confinc" > confmf
# We grep out `Entering directory' and `Leaving directory'
# messages which can occur if `w' ends up in MAKEFLAGS.
# In particular we don't look at `^make:' because GNU make might
# be invoked under some other name (usually "gmake"), in which
# case it prints its new name instead of `make'.
if test "`$am_make -s -f confmf 2> /dev/null | grep -v 'ing directory'`" = "done"; then
   am__include=include
   am__quote=
   _am_result=GNU
fi
# Now try BSD make style include.
if test "$am__include" = "#"; then
   echo '.include "confinc"' > confmf
   if test "`$am_make -s -f confmf 2> /dev/null`" = "done"; then
      am__include=.include
      am__quote="\""
      _am_result=BSD
   fi
fi
AC_SUBST([am__include])
AC_SUBST([am__quote])
AC_MSG_RESULT([$_am_result])
rm -f confinc confmf
])

# Fake the existence of programs that GNU maintainers use.  -*- Autoconf -*-

# Copyright (C) 1997, 1999, 2000, 2001, 2003, 2005
# Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 4

# AM_MISSING_PROG(NAME, PROGRAM)
# ------------------------------
AC_DEFUN([AM_MISSING_PROG],
[AC_REQUIRE([AM_MISSING_HAS_RUN])
$1=${$1-"${am_missing_run}$2"}
AC_SUBST($1)])


# AM_MISSING_HAS_RUN
# ------------------
# Define MISSING if not defined so far and test if it supports --run.
# If it does, set am_missing_run to use it, otherwise, to nothing.
AC_DEFUN([AM_MISSING_HAS_RUN],
[AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
test x"${MISSING+set}" = xset || MISSING="\${SHELL} $am_aux_dir/missing"
# Use eval to expand $SHELL
if eval "$MISSING --run true"; then
  am_missing_run="$MISSING --run "
else
  am_missing_run=
  AC_MSG_WARN([`missing' script is too old or missing])
fi
])

# Copyright (C) 2003, 2004, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# AM_PROG_MKDIR_P
# ---------------
# Check whether `mkdir -p' is supported, fallback to mkinstalldirs otherwise.
#
# Automake 1.8 used `mkdir -m 0755 -p --' to ensure that directories
# created by `make install' are always world readable, even if the
# installer happens to have an overly restrictive umask (e.g. 077).
# This was a mistake.  There are at least two reasons why we must not
# use `-m 0755':
#   - it causes special bits like SGID to be ignored,
#   - it may be too restrictive (some setups expect 775 directories).
#
# Do not use -m 0755 and let people choose whatever they expect by
# setting umask.
#
# We cannot accept any implementation of `mkdir' that recognizes `-p'.
# Some implementations (such as Solaris 8's) are not thread-safe: if a
# parallel make tries to run `mkdir -p a/b' and `mkdir -p a/c'
# concurrently, both version can detect that a/ is missing, but only
# one can create it and the other will error out.  Consequently we
# restrict ourselves to GNU make (using the --version option ensures
# this.)
AC_DEFUN([AM_PROG_MKDIR_P],
[if mkdir -p --version . >/dev/null 2>&1 && test ! -d ./--version; then
  # We used to keeping the `.' as first argument, in order to
  # allow $(mkdir_p) to be used without argument.  As in
  #   $(mkdir_p) $(somedir)
  # where $(somedir) is conditionally defined.  However this is wrong
  # for two reasons:
  #  1. if the package is installed by a user who cannot write `.'
  #     make install will fail,
  #  2. the above comment should most certainly read
  #     $(mkdir_p) $(DESTDIR)$(somedir)
  #     so it does not work when $(somedir) is undefined and
  #     $(DESTDIR) is not.
  #  To support the latter case, we have to write
  #     test -z "$(somedir)" || $(mkdir_p) $(DESTDIR)$(somedir),
  #  so the `.' trick is pointless.
  mkdir_p='mkdir -p --'
else
  # On NextStep and OpenStep, the `mkdir' command does not
  # recognize any option.  It will interpret all options as
  # directories to create, and then abort because `.' already
  # exists.
  for d in ./-p ./--version;
  do
    test -d $d && rmdir $d
  done
  # $(mkinstalldirs) is defined by Automake if mkinstalldirs exists.
  if test -f "$ac_aux_dir/mkinstalldirs"; then
    mkdir_p='$(mkinstalldirs)'
  else
    mkdir_p='$(install_sh) -d'
  fi
fi
AC_SUBST([mkdir_p])])

# Helper functions for option handling.                     -*- Autoconf -*-

# Copyright (C) 2001, 2002, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 3

# _AM_MANGLE_OPTION(NAME)
# -----------------------
AC_DEFUN([_AM_MANGLE_OPTION],
[[_AM_OPTION_]m4_bpatsubst($1, [[^a-zA-Z0-9_]], [_])])

# _AM_SET_OPTION(NAME)
# ------------------------------
# Set option NAME.  Presently that only means defining a flag for this option.
AC_DEFUN([_AM_SET_OPTION],
[m4_define(_AM_MANGLE_OPTION([$1]), 1)])

# _AM_SET_OPTIONS(OPTIONS)
# ----------------------------------
# OPTIONS is a space-separated list of Automake options.
AC_DEFUN([_AM_SET_OPTIONS],
[AC_FOREACH([_AM_Option], [$1], [_AM_SET_OPTION(_AM_Option)])])

# _AM_IF_OPTION(OPTION, IF-SET, [IF-NOT-SET])
# -------------------------------------------
# Execute IF-SET if OPTION is set, IF-NOT-SET otherwise.
AC_DEFUN([_AM_IF_OPTION],
[m4_ifset(_AM_MANGLE_OPTION([$1]), [$2], [$3])])

# Copyright (C) 2001, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# AM_RUN_LOG(COMMAND)
# -------------------
# Run COMMAND, save the exit status in ac_status, and log it.
# (This has been adapted from Autoconf's _AC_RUN_LOG macro.)
AC_DEFUN([AM_RUN_LOG],
[{ echo "$as_me:$LINENO: $1" >&AS_MESSAGE_LOG_FD
   ($1) >&AS_MESSAGE_LOG_FD 2>&AS_MESSAGE_LOG_FD
   ac_status=$?
   echo "$as_me:$LINENO: \$? = $ac_status" >&AS_MESSAGE_LOG_FD
   (exit $ac_status); }])

# Check to make sure that the build environment is sane.    -*- Autoconf -*-

# Copyright (C) 1996, 1997, 2000, 2001, 2003, 2005
# Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 4

# AM_SANITY_CHECK
# ---------------
AC_DEFUN([AM_SANITY_CHECK],
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftest.file
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftest.file 2> /dev/null`
   if test "$[*]" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftest.file`
   fi
   rm -f conftest.file
   if test "$[*]" != "X $srcdir/configure conftest.file" \
      && test "$[*]" != "X conftest.file $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "$[2]" = conftest.file
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
AC_MSG_RESULT(yes)])

# Copyright (C) 2001, 2003, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# AM_PROG_INSTALL_STRIP
# ---------------------
# One issue with vendor `install' (even GNU) is that you can't
# specify the program used to strip binaries.  This is especially
# annoying in cross-compiling environments, where the build's strip
# is unlikely to handle the host's binaries.
# Fortunately install-sh will honor a STRIPPROG variable, so we
# always use install-sh in `make install-strip', and initialize
# STRIPPROG with the value of the STRIP variable (set by the user).
AC_DEFUN([AM_PROG_INSTALL_STRIP],
[AC_REQUIRE([AM_PROG_INSTALL_SH])dnl
# Installed binaries are usually stripped using `strip' when the user
# run `make install-strip'.  However `strip' might not be the right
# tool to use in cross-compilation environments, therefore Automake
# will honor the `STRIP' environment variable to overrule this program.
dnl Don't test for $cross_compiling = yes, because it might be `maybe'.
if test "$cross_compiling" != no; then
  AC_CHECK_TOOL([STRIP], [strip], :)
fi
INSTALL_STRIP_PROGRAM="\${SHELL} \$(install_sh) -c -s"
AC_SUBST([INSTALL_STRIP_PROGRAM])])

# Check how to create a tarball.                            -*- Autoconf -*-

# Copyright (C) 2004, 2005  Free Software Foundation, Inc.
#
# This file is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# serial 2

# _AM_PROG_TAR(FORMAT)
# --------------------
# Check how to create a tarball in format FORMAT.
# FORMAT should be one of `v7', `ustar', or `pax'.
#
# Substitute a variable $(am__tar) that is a command
# writing to stdout a FORMAT-tarball containing the directory
# $tardir.
#     tardir=directory && $(am__tar) > result.tar
#
# Substitute a variable $(am__untar) that extract such
# a tarball read from stdin.
#     $(am__untar) < result.tar
AC_DEFUN([_AM_PROG_TAR],
[# Always define AMTAR for backward compatibility.
AM_MISSING_PROG([AMTAR], [tar])
m4_if([$1], [v7],
     [am__tar='${AMTAR} chof - "$$tardir"'; am__untar='${AMTAR} xf -'],
     [m4_case([$1], [ustar],, [pax],,
              [m4_fatal([Unknown tar format])])
AC_MSG_CHECKING([how to create a $1 tar archive])
# Loop over all known methods to create a tar archive until one works.
_am_tools='gnutar m4_if([$1], [ustar], [plaintar]) pax cpio none'
_am_tools=${am_cv_prog_tar_$1-$_am_tools}
# Do not fold the above two line into one, because Tru64 sh and
# Solaris sh will not grok spaces in the rhs of `-'.
for _am_tool in $_am_tools
do
  case $_am_tool in
  gnutar)
    for _am_tar in tar gnutar gtar;
    do
      AM_RUN_LOG([$_am_tar --version]) && break
    done
    am__tar="$_am_tar --format=m4_if([$1], [pax], [posix], [$1]) -chf - "'"$$tardir"'
    am__tar_="$_am_tar --format=m4_if([$1], [pax], [posix], [$1]) -chf - "'"$tardir"'
    am__untar="$_am_tar -xf -"
    ;;
  plaintar)
    # Must skip GNU tar: if it does not support --format= it doesn't create
    # ustar tarball either.
    (tar --version) >/dev/null 2>&1 && continue
    am__tar='tar chf - "$$tardir"'
    am__tar_='tar chf - "$tardir"'
    am__untar='tar xf -'
    ;;
  pax)
    am__tar='pax -L -x $1 -w "$$tardir"'
    am__tar_='pax -L -x $1 -w "$tardir"'
    am__untar='pax -r'
    ;;
  cpio)
    am__tar='find "$$tardir" -print | cpio -o -H $1 -L'
    am__tar_='find "$tardir" -print | cpio -o -H $1 -L'
    am__untar='cpio -i -H $1 -d'
    ;;
  none)
    am__tar=false
    am__tar_=false
    am__untar=false
    ;;
  esac

  # If the value was cached, stop now.  We just wanted to have am__tar
  # and am__untar set.
  test -n "${am_cv_prog_tar_$1}" && break

  # tar/untar a dummy directory, and stop if the command works
  rm -rf conftest.dir
  mkdir conftest.dir
  echo GrepMe > conftest.dir/file
  AM_RUN_LOG([tardir=conftest.dir && eval $am__tar_ >conftest.tar])
  rm -rf conftest.dir
  if test -s conftest.tar; then
    AM_RUN_LOG([$am__untar <conftest.tar])
    grep GrepMe conftest.dir/file >/dev/null 2>&1 && break
  fi
done
rm -rf conftest.dir

AC_CACHE_VAL([am_cv_prog_tar_$1], [am_cv_prog_tar_$1=$_am_tool])
AC_MSG_RESULT([$am_cv_prog_tar_$1])])
AC_SUBST([am__tar])
AC_SUBST([am__untar])
]) # _AM_PROG_TAR

dnl -*- m4 -*-
dnl----------------------------------------------------------------------
dnl This is a common set of macros to be used in the configuration of
dnl	the LDAS software
dnl----------------------------------------------------------------------

dnl======================================================================
dnl Get the list of recursive targets automatically supplied by automake
dnl======================================================================

AC_DEFUN([LDAS_CHECK_AUTOMAKE_RECURSIVE_TARGETS],
  [AC_CACHE_CHECK([find recursive targets used by automake],
    [ldas_cv_automake_recursive_targets],
    [ dnl ---------------------------------------------------------------
      dnl  Find all of the recursive targets
      dnl ---------------------------------------------------------------
     ldas_cv_automake_recursive_targets="`egrep -e '^(.*):.*\1-recursive$' ${srcdir}/Makefile.in | egrep -v -e '^(mostlyclean|clean|distclean|maintainer-clean):' | sed -e 's/:.*$/-recursive/' | tr '\n' ' '`"
    ])
  PROJECT_RECURSIVE_TARGETS="${ldas_cv_automake_recursive_targets} $PROJECT_RECURSIVE_TARGETS"
  AC_SUBST(PROJECT_RECURSIVE_TARGETS)]
)

dnl======================================================================
dnl LDAS_CHECK_PTHREAD_READ_WRITE_LOCK - See if anything special has
dnl	to be done to compile pthread's read/write locks
dnl======================================================================

AC_DEFUN([LDAS_CHECK_PTHREAD_READ_WRITE_LOCK],
[
AC_CHECK_HEADER(pthread.h)
AC_MSG_CHECKING(for additional flags to compile read/write locking for threads)
AC_CACHE_VAL(ldas_cv_pthread_read_write_lock_option,
[ldas_cv_pthread_read_write_lock_option=no
AC_LANG_SAVE
AC_LANG_C
ac_save_CFLAGS="$CFLAGS"
ac_save_CXXFLAGS="$CXXFLAGS"
for ac_arg in ""
do
  CFLAGS="$ac_save_CFLAGS $ac_arg"
  AC_TRY_COMPILE(
  [#include <pthread.h>
  ],[
  pthread_rwlock_t l;
  pthread_rwlock_init( &l, (pthread_rwlockattr_t*)NULL );
  ],
  [ldas_cv_pthread_read_write_lock_option="$ac_arg"; break; ],
  [ldas_cv_pthread_read_write_lock_option="unsupported"])
done
CFLAGS="$ac_save_CFLAGS"
])
if test -z "$ldas_cv_pthread_read_write_lock_option"
then
  AC_MSG_RESULT([none needed])
else
  AC_MSG_RESULT([$ldas_cv_pthread_read_write_lock_option])
fi
case "x$ldas_cv_pthread_read_write_lock_option" in
  xno|xunsupported) ;;
  x)
    AC_DEFINE([HAVE_PTHREAD_RW_LOCK],
	      [1],
	      [Defined if pthread read/write locks supported])
    ;;
  *)
    AC_DEFINE([HAVE_PTHREAD_RW_LOCK],
	      [1],
	      [Defined if pthread read/write locks supported])
    CFLAGS="$CFLAGS $ldas_cv_pthread_read_write_lock_option"
    CXXFLAGS="$CXXFLAGS $ldas_cv_pthread_read_write_lock_option"
    ;;
esac
AC_LANG_RESTORE
])

dnl======================================================================
dnl LDAS_CALC_VERSION - Calculate the version number
dnl======================================================================

AC_DEFUN([LDAS_INIT_AUTOMAKE],
[
if test x$LDAS_VERSION = x
then
	LDAS_VERSION=$2
	export LDAS_VERSION
fi
AM_INIT_AUTOMAKE($1,$2)
])

dnl======================================================================
dnl AC_LDAS_FINISH - Things to be done at the very end for LDAS
dnl======================================================================

AC_DEFUN([AC_LDAS_FINISH],
[
  dnl -------------------------------------------------------------------
  dnl Check for large file support
  dnl -------------------------------------------------------------------
  AC_SYS_LARGEFILE
  dnl -------------------------------------------------------------------
  dnl -- Check for documentation tools
  dnl -------------------------------------------------------------------
  LDAS_PROG_DOXYGEN
  dnl -------------------------------------------------------------------
  dnl -- Check for the presence of Valgrind
  dnl -------------------------------------------------------------------
  LDAS_PROG_VALGRIND
  LDAS_LIB_UMEM
  LDAS_LIB_STLPORT_FINISH
  AC_SUBST(LDAS_EMPTY)
  dnl ===================================================================
  dnl  Specify memory checker
  dnl ===================================================================
  AC_ARG_WITH([memory-checking],[  --with-memory-checking[[=no]]  enable extended runtime memory checking],
	      [],
              [with_memory_checking="no"])
  case x$with_memory_checking in
  xno)
    AC_MSG_CHECKING(for memory checking)
    AC_MSG_RESULT(no)
    ;;
  x|xyes)
    AC_LANG_PUSH(C++)
    AC_MSG_CHECKING(for memory checking C++)
    ldas_memory_checking_flags=""
    ldas_orig_CXXFLAGS="$CXXFLAGS"
    dnl -----------------------------------------------------------------
    dnl  -fmudflapth
    dnl -----------------------------------------------------------------
    CXXFLAGS="-fmudflapth $ldas_orig_CXXFLAGS"
    AC_RUN_IFELSE([int main( ) { return( 0 ); }],
	          [ ldas_memory_checking_flags="-fmudflapth $ldas_memory_checking_flags" ],[],[])
    dnl -----------------------------------------------------------------
    dnl  -bounds-check
    dnl -----------------------------------------------------------------
    CXXFLAGS="-fbounds-check $ldas_orig_CXXFLAGS"
    AC_RUN_IFELSE([int main( ) { return( 0 ); }],
	          [ ldas_memory_checking_flags="-fbounds-check $ldas_memory_checking_flags" ],[],[])
    dnl -----------------------------------------------------------------
    dnl  -stack-check
    dnl -----------------------------------------------------------------
    CXXFLAGS="-fstack-check $ldas_orig_CXXFLAGS"
    AC_RUN_IFELSE([int main( ) { return( 0 ); }],
	          [ ldas_memory_checking_flags="-fstack-check $ldas_memory_checking_flags" ],[],[])
    dnl -----------------------------------------------------------------
    dnl Finish with memory checks
    dnl -----------------------------------------------------------------
    CXXFLAGS="$ldas_memory_checking_flags $ldas_orig_CXXFLAGS"
    AC_MSG_RESULT($ldas_memory_checking_flags)
    AC_LANG_POP(C++)
    AC_LANG_PUSH(C)
    AC_MSG_CHECKING(for memory checking C)
    ldas_memory_checking_flags=""
    ldas_orig_CFLAGS="$CFLAGS"
    dnl -----------------------------------------------------------------
    dnl  -fmudflapth
    dnl -----------------------------------------------------------------
    CFLAGS="-fmudflapth $ldas_orig_CFLAGS"
    AC_RUN_IFELSE([int main( ) { return( 0 ); }],
	          [ ldas_memory_checking_flags="-fmudflapth $ldas_memory_checking_flags" ],[],[])
    dnl -----------------------------------------------------------------
    dnl  -bounds-check
    dnl -----------------------------------------------------------------
    CFLAGS="-fbounds-check $ldas_orig_CFLAGS"
    AC_RUN_IFELSE([int main( ) { return( 0 ); }],
	          [ ldas_memory_checking_flags="-fbounds-check $ldas_memory_checking_flags" ],[],[])
    dnl -----------------------------------------------------------------
    dnl  -stack-check
    dnl -----------------------------------------------------------------
    CFLAGS="-fstack-check $ldas_orig_CFLAGS"
    AC_RUN_IFELSE([int main( ) { return( 0 ); }],
	          [ ldas_memory_checking_flags="-fstack-check $ldas_memory_checking_flags" ],[],[])
    dnl -----------------------------------------------------------------
    dnl Finish with memory checks
    dnl -----------------------------------------------------------------
    CFLAGS="$ldas_memory_checking_flags $ldas_orig_CFLAGS"
    AC_MSG_RESULT($ldas_memory_checking_flags)
    AC_LANG_POP(C)
    ;;
  esac
  dnl ===================================================================
  dnl  Specify Arch optimiations
  dnl ===================================================================
  AC_MSG_CHECKING(for architecture optimization)
  AC_ARG_WITH([opt-arch],[  --with-opt-arch[[=no]]            enable cpu archtecture optimization],
                [],
                [with_opt_arch="no"])
  case x$with_opt_arch in
  xno)
    ;;
  x|xyes)
    case "`uname -m`" in
    i686)
      opt_arch="pentium4";
      ;;
    sun4u)
      opt_arch="v8plus";
      ;;
    esac
    ;;
  *)
    opt_arch="$with_opt_arch";
    ;;
  esac
  case x$with_opt_arch in
  xno)
    ;;
  *)
    case x$LDAS_CC_FLAVOR in
    xgnu)
      case "`uname -m`" in
      i*86)
        opt_arch_flag="-march=";
        ;;
      sun4u)
        opt_arch_flag="-mfpu -mno-unaligned-doubles -Wa,-xarch=v8plusb -m";
        ;;
      esac
      CFLAGS="$opt_arch_flag$opt_arch $CFLAGS"
      ;;
    xSunPRO)
      case x$opt_arch in
      xv8plus)
        CFLAGS="-xarch=${opt_arch}a $CFLAGS"
        ;;
      esac
      ;;
    esac
    case x$LDAS_CXX_FLAVOR in
    xgnu)
      case "`uname -m`" in
      i*86)
        opt_arch_flag="-march=";
        ;;
      sun4u)
        opt_arch_flag="-mfpu -mno-unaligned-doubles -Wa,-xarch=v8plusb -m";
        ;;
      esac
      CXXFLAGS="$opt_arch_flag$opt_arch $CXXFLAGS"
      ;;
    xSunPRO)
      case x$opt_arch in
      xv8plus)
        CXXFLAGS="-xarch=${opt_arch}a $CXXFLAGS"
        ;;
      esac
      ;;
    esac
    ;;
  esac
  case x$opt_arch in
  x)
    AC_MSG_RESULT(none)
    ;;
  *)
    AC_MSG_RESULT($opt_arch)
    ;;
  esac

  dnl ===================================================================
  dnl  Specify warning message level
  dnl ===================================================================
  CFLAGS="${ldas_prog_cc_warning} ${CFLAGS}"
  CXXFLAGS="${ldas_prog_cxx_warning} ${CXXFLAGS}"

if test "x$LDAS_LIBTOOL_VERSION_FLAG" = x
then
  LDAS_LIBTOOL_VERSION_FLAG="`echo ${LDAS_VERSION} | sed -e 's/\([[0-9]][[0-9]]*\)\.\([[0-9]][[0-9]]*\)\.\([[0-9]][[0-9]]*\)/-release \1 -version-info \2:\3:0/g'`";
  export LDAS_LIBTOOL_VERSION_FLAG;
fi
if test "x$LDAS_SO" = x
then
  LDAS_SO="`echo ${LDAS_VERSION} | sed -e 's/\([[0-9]][[0-9]]*\)\.\([[0-9]][[0-9]]*\)\.\([[0-9]][[0-9]]*\)/-\1.so.\2.0.\3/g'`";
  export LDAS_SO;
fi
dnl =====================================================================
dnl  Optimization
dnl =====================================================================
AC_LDAS_ARG_WITH_OPTIMIZATION
dnl -----------------------------------------------------------------------
CFLAGS="$LDAS_DEFS $CFLAGS"
echo "$CFLAGS" | egrep -e ${ldas_prog_cc_optimization_key}'[[0-9]]'
if test $? -ne 0
then
  CFLAGS="$CFLAGS ${ldas_prog_cc_optimization}"
else
  CFLAGS="`echo $CFLAGS | sed -e 's/'${ldas_prog_cc_optimization_key}'[[0-9]]/'${ldas_prog_cc_optimization}'/g'`"
fi
dnl -----------------------------------------------------------------------
echo "$LDAS_DEFS $CXXFLAGS" | egrep -e ${ldas_prog_cxx_optimization_key}'[[0-9]]'
if test $? -ne 0
then
  CXXFLAGS="$LDAS_DEFS $CXXFLAGS ${ldas_prog_cxx_optimization}"
else
  CXXFLAGS="`echo $LDAS_DEFS $CXXFLAGS | sed -e 's/'${ldas_prog_cxx_optimization_key}'[[0-9]]/'${ldas_prog_cxx_optimization}'/g'`"
fi
dnl -----------------------------------------------------------------------
dnl -- figure out which directories really exist
dnl -----------------------------------------------------------------------
if test -n "${subdirs}"
then
  for dir in ${subdirs}
  do
    if test -d ${srcdir}/${dir}
    then
      ldas_finish_subdirs="${ldas_finish_subdirs} ${dir}"
    fi
  done
  subdirs="${ldas_finish_subdirs}"
fi

dnl -- thread safety
AC_ARG_WITH(
        threads,
        [  --without-threads       Don't build reentrant code ],
        [ case x"$with_threads" in
          "x"|xno) ;;
          *)
		CFLAGS="${CFLAGS} -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS"
		CXXFLAGS="${CXXFLAGS} -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS"
		LDAS_CHECK_PTHREAD_READ_WRITE_LOCK
		;;
	  esac
	],[
	  CFLAGS="${CFLAGS} -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS"
	  CXXFLAGS="${CXXFLAGS} -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS"
	  LDAS_CHECK_PTHREAD_READ_WRITE_LOCK
	])


dnl -- check for unrolling of inlined functions
AC_ARG_ENABLE(inlining,
	[ --disable-inlining	Build without inlining],
	[],
	[enable_inlining=default])

case x${enable_inlining} in
xno)
  if test "${GCC}" = "yes"
  then
    CFLAGS="${CFLAGS} -fno-inline"
  fi
  if test "${GXX}" = "yes"
  then
    CXXFLAGS="${CXXFLAGS} -fno-inline"
  fi
  ;;
xyes)
  if test "${GCC}" = "yes"
  then
    FLAGS="${CFLAGS} -finline"
  fi
  if test "${GXX}" = "yes"
  then
    CXXFLAGS="${CXXFLAGS} -finline"
  fi
  ;;
*)
  ;;
esac

dnl -- rearrange prefix directories

CXXFLAGS="`echo $CXXFLAGS |  tr ' \011' '\012\012' | grep -v -- '-[[IL]]'${prefix} |  tr '\012' ' '``echo $CXXFLAGS | tr ' \011' '\012\012' | grep -- '-[[IL]]'${prefix} | sort | uniq | tr '\012' ' '`"
CPPFLAGS="`echo $CPPFLAGS |  tr ' \011' '\012\012' | grep -v -- '-[[IL]]'${prefix} |  tr '\012' ' '``echo $CPPFLAGS | tr ' \011' '\012\012' | grep -- '-[[IL]]'${prefix} | sort | uniq | tr '\012' ' '`"
LDFLAGS="`echo $LDFLAGS |  tr ' \011' '\012\012' | grep -v -- '-[[IL]]'${prefix} |  tr '\012' ' '``echo $LDFLAGS | tr ' \011' '\012\012' | grep -- '-[[IL]]'${prefix} | sort | uniq | tr '\012' ' '`"

AC_LDAS_WITH_PROFILE
AC_LDAS_WITH_LDAS_TARGET
AC_LDAS_WITH_MOUNT_PT
AC_SUBST(LDAS_PACKAGE_NAME)
AC_SUBST(LDAS_PACKAGE_VERSION)
AC_SUBST(LDAS_LIBTOOL_VERSION_FLAG)
AC_SUBST(LDAS_SO)
])

dnl======================================================================
dnl AC_LDAS_INIT([top]) - Initializes the LDAS macro set. If top is
dnl	passed to the macro, then the current directory will be 
dnl	taken as the top most directory of the LDAS system.
dnl======================================================================

AC_DEFUN([AC_LDAS_INIT],
[
  dnl -------------------------------------------------------------------
  dnl  Information about the current system for which LDAS is being
  dnl    configured.
  dnl -------------------------------------------------------------------
  ldas_kernel=`uname -s`
  ldas_processor=`uname -p`
  ldas_hardware=`uname -i`
  dnl -------------------------------------------------------------------
  dnl Misc. Info
  dnl -------------------------------------------------------------------
  ldas_top=""
  if test -n "$1" && test "$1" = "top"
  then
    ldas_top="."
    touch .ldas_top
  else
    for dir in .. ../.. ../../.. ../../../..
    do
      if test -f ${dir}/.ldas_top
      then
  	ldas_top="${dir}"
  	break
      fi
    done
  fi
  ldas_top_srcdir='[$][(]top_srcdir[)]/'${ldas_top}
  ldas_top_builddir='[$][(]top_builddir[)]/'${ldas_top}
  dnl -------------------------------------------------------------------
  dnl  Check if user has custom requests
  dnl -------------------------------------------------------------------
  AC_LDAS_WITH_EXTRA_CXXFLAGS
  AC_LDAS_WITH_EXTRA_LDFLAGS
  AC_LDAS_ENABLE_AUTO_LDCG_INCLUSION
  AC_LDAS_PROG_CC
  dnl -- Automatically add /ldcg into the build
  if test x$enable_auto_ldcg_inclusion == xyes && test -d /ldcg
  then
    case x$enable_64bit in
    xyes)
      AC_LDAS_VAR_APPEND(CFLAGS,/ldcg/include64)
      AC_LDAS_VAR_APPEND(CXXFLAGS,/ldcg/include64)
      if test -d /ldcg/lib/64 || test -h /ldcg/lib/64
      then
        AC_LDAS_VAR_APPEND(LDFLAGS,[-Wl,${RPATH},/ldcg/lib/64])
        AC_LDAS_VAR_APPEND(LDFLAGS,-L/ldcg/lib/64)
      else
        AC_LDAS_VAR_APPEND(LDFLAGS,[-Wl,${RPATH},/ldcg/lib64])
        AC_LDAS_VAR_APPEND(LDFLAGS,-L/ldcg/lib64)
      fi
      ;;
    esac
    AC_LDAS_VAR_APPEND(CFLAGS,/ldcg/include)
    AC_LDAS_VAR_APPEND(CXXFLAGS,/ldcg/include)
    AC_LDAS_VAR_APPEND(LDFLAGS,[-Wl,${RPATH},/ldcg/lib])
    AC_LDAS_VAR_APPEND(LDFLAGS,-L/ldcg/lib)
  fi
  AC_LDAS_WITH_LDFLAGS
  dnl -------------------------------------------------------------------
  dnl Export meaningful information
  dnl -------------------------------------------------------------------
  AC_SUBST(ldas_top)
  AC_SUBST(ldas_top_srcdir)
  AC_SUBST(ldas_top_builddir)

  dnl -------------------------------------------------------------------
  dnl Some variable that may or may not be set, but will be used.
  dnl -------------------------------------------------------------------
  AC_SUBST(EXTRA_LIBS)
  LDAS_LIB_STLPORT
  dnl -------------------------------------------------------------------
  dnl  Additional recursive targets
  dnl -------------------------------------------------------------------
  LDAS_CHECK_AUTOMAKE_RECURSIVE_TARGETS
  PROJECT_RECURSIVE_TARGETS="memcheck-recursive $PROJECT_RECURSIVE_TARGETS"
])

dnl======================================================================
dnl Check for the enabling of certain flags
dnl======================================================================
AC_DEFUN([AC_LDAS_ARG_ENABLE_64BIT],[
  dnl''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  dnl Check if 
  dnl''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  AC_ARG_ENABLE(64bit,
	[ --enable-64bit	Build 64-bit binaries],
	[enable_64bit="yes"],
	[enable_64bit="no"])
  case "${enable_64bit}" in
  yes)
    dnl''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    dnl Setup Linker
    dnl''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    if test $ldas_kernel = SunOS
    then
      if test -d /ldcg
      then 
        if test $ldas_kernel = SunOS
        then
	  AC_LDAS_VAR_PREPEND(LDFLAGS,-L/ldcg/lib/64)
          AC_LDAS_VAR_PREPEND(LDFLAGS,[-Wl,${RPATH},/ldcg/lib/64])
        fi
      fi
    fi
    dnl AC_LDAS_VAR_PREPEND(LDFLAGS,-m64)
    dnl :TODO: Verify if the following line is even needed
    dnl AC_LDAS_VAR_PREPEND(LIBS,[-Wl,-m64])
    ;;
  *)
    ;;
  esac # enable_64bit
])

dnl======================================================================
dnl Checking for the existence of certain libraries
dnl======================================================================

AC_DEFUN([AC_LDAS_CHECK_LIB_Z],
[ have_libz='yes'
  AC_CHECK_LIB( 
	z,
	compress,
	[ AC_DEFINE( HAVE_LIBZ,1,[Defined if have libz] )
	  AC_CHECK_LIB(z, compress2,[AC_DEFINE( HAVE_LIBZ_COMPRESS2,1,[Defined if libz had compress2 function] )]) ],
	[ if test -n "$1" && test "$1" = "no"
	  then
		AC_MSG_WARN( Required zlib library (libz.a) not found ) 
	        have_libz='';
	  else
		AC_MSG_ERROR( Required zlib library (libz.a) not found ) 
	  fi
	])
  AM_CONDITIONAL(HAVE_LIBZ, test x$have_libz != x)
])


AC_DEFUN([AC_LDAS_CHECK_LIB_BZ2],
[ have_libbz2='yes'
  AC_CHECK_LIB(bz2,BZ2_bzBuffToBuffCompress,
  [ AC_DEFINE( HAVE_NEW_LIBZ2,1,[Defined if libz2 has new functions] ) ],
  [ AC_CHECK_LIB(bz2, bzBuffToBuffCompress,,
    [ if test -n "$1" && test "$1" = "no"
      then
        AC_MSG_WARN( Library libbz2 not found )
	have_libbz2=''
      else
        AC_MSG_ERROR( Required library libbz2 not found )
      fi
    ])
  ])
  AM_CONDITIONAL(HAVE_LIBBZ2, test x$have_libbz2 != x)
])

   
dnl======================================================================
dnl Checking arguments that were passed to configure
dnl======================================================================

dnl----------------------------------------------------------------------
dnl Routines for appending to certain variables
dnl----------------------------------------------------------------------

AC_DEFUN([AC_LDAS_PREFIX_LDFLAGS],
[ for lib in $1
  do
    AC_LDAS_VAR_PREPEND(LDFLAGS,${lib})
  done
])

AC_DEFUN([AC_LDAS_PREFIX_INCLUDE_PATH],
[ for inc in $1
  do
    AC_LDAS_VAR_APPEND(CPPFLAGS,${inc},-I)
  done
])

dnl======================================================================
dnl AC_LDAS_ENABLE_AUTO_LDCG_INCLUSION
dnl======================================================================

AC_DEFUN([AC_LDAS_ENABLE_AUTO_LDCG_INCLUSION],
[AC_ARG_ENABLE([auto-ldcg-inclusion],[enables/disables inclusion of /ldcg],,[enable_auto_ldcg_inclusion="yes"])])

dnl======================================================================
dnl AC_LDAS_WITH_MOUNTPT
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_MOUNT_PT],
[AC_ARG_WITH(
	mountpt, 
	[  --with-mountpt          Specify frame builder directory],
	[ 
		MOUNT_PT="$mountpt";
	],[
		MOUNT_PT="/imports/frames";
	])
	AC_SUBST(MOUNT_PT)
])

dnl======================================================================
dnl AC_LDAS_WITH_CCMALLOC
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_CCMALLOC],
[AC_ARG_WITH(
	ccmalloc, 
	[  --with-ccmalloc         Link to ccmalloc when running tests],
	[ AC_CHECK_LIB( 
		ccmalloc,
		main,
		[ EXTRA_TEST_FLAGS='-lccmalloc -ldl' ],
		[ AC_MSG_WARN( ccmalloc not found )  ])
	])
	AC_SUBST(EXTRA_TEST_FLAGS)
])

dnl======================================================================
dnl AC_LDAS_WITH_EXTRA_CXXFLAGS
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_EXTRA_CXXFLAGS],
[AC_ARG_WITH(
	extra_cxxflags, 
	[  --with-extra-cxxflags   Additional C++ compiler flags],
	[ if test -n "${with_extra_cxxflags}"
	  then
	    AC_LDAS_VAR_APPEND(CXXFLAGS,${with_extra_cxxflags},LITERAL)
	  fi
	],)
])

dnl======================================================================
dnl AC_LDAS_WITH_EXTRA_LDFLAGS
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_EXTRA_LDFLAGS],
[AC_ARG_WITH(
	extra_ldflags, 
	[  --with-extra-ldflags    Additional linker flags],
	[ if test -n "${with_extra_ldflags}"
	  then
	    LDFLAGS="$LDFLAGS ${with_extra_ldflags}";
	  fi
	],)
])


dnl======================================================================
dnl AC_LDAS_WITH_LDFLAGS
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_LDFLAGS],
[AC_ARG_WITH(
	ldflags, 
	[  --with-ldflags          Replace linker flags],
	[ if test -n "${with_ldflags}"
	  then
	    LDFLAGS="${with_ldflags}";
	  fi
	],)
])

dnl======================================================================
dnl AC_LDAS_WITH_LDAS_TARGET
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_LDAS_TARGET],
[AC_ARG_WITH(
	ldas_target,
	[  --with-ldas-target=[production|development|system_test]
                          Create target specific LDAS resource file ],
	[ case "${with_ldas_target}" in
	  production) BASE_PORT="11000";;
	  system_test) BASE_PORT="13000";;
	  development|*) BASE_PORT="12000";;
	  esac
	],[BASE_PORT="12000"])
	AC_SUBST(BASE_PORT)
])

dnl======================================================================
dnl AC_LDAS_WITH_PROFLE
dnl======================================================================

AC_DEFUN([AC_LDAS_WITH_PROFILE],
[AC_ARG_WITH(
	profile, 
	[  --with-profile=[prof|gprof] 
                          Compile for profiling ],
	[ if test "${with_profile}" = "prof"
	  then
	    CXXFLAGS="$CXXFLAGS -p";
	  elif  test "${with_profile}" = "gprof"
	  then
	    CXXFLAGS="$CXXFLAGS -pg";
	  else
	    AC_MSG_ERROR( Supported profiling modes: prof gprof. );
	  fi
	],)
])


dnl======================================================================
dnl AC_LDAS_ARG_WITH_OPTIMIZATION
dnl======================================================================

AC_DEFUN([AC_LDAS_ARG_WITH_OPTIMIZATION],
[AC_ARG_WITH(
	optimization,
	[  --with-optimization     Compiler optimization (extreme|high|medium|low|none)],
	[ ],[with_optimization="medium"])
	case x$CC in
	x) ;; dnl ignore because it has not been set
	*)
	  case x${with_optimization} in
	  xnone) dnl -- none
	    ldas_prog_cc_optimization=$ldas_prog_cc_optimization_none
            ;;
	  xextreme) dnl -- extreme
            ldas_prog_cc_optimization=$ldas_prog_cc_optimization_extreme
	    ;;
	  xhigh) dnl -- high
	    ldas_prog_cc_optimization=$ldas_prog_cc_optimization_high
   	    ;;
          xlow) dnl -- low
            ldas_prog_cc_optimization=$ldas_prog_cc_optimization_low
            ;;
	  xdefault) dnl -- default
            ldas_prog_cc_optimization=$ldas_prog_cc_optimization_default
            ;;
          *) dnl -- all other cases
	    ldas_prog_cc_optimization=$ldas_prog_cc_optimization_medium
	    ;;
	  esac
	  ;;
	esac
	case x$CXX in
	x) ;; dnl ignore because it has not been set
	*)
	  case x${with_optimization} in
	  xnone) dnl -- none
	    ldas_prog_cxx_optimization=$ldas_prog_cxx_optimization_none
            ;;
	  xextreme) dnl -- extreme
            ldas_prog_cxx_optimization=$ldas_prog_cxx_optimization_extreme
	    ;;
	  xhigh) dnl -- high
	    ldas_prog_cxx_optimization=$ldas_prog_cxx_optimization_high
   	    ;;
          xlow) dnl -- low
            ldas_prog_cxx_optimization=$ldas_prog_cxx_optimization_low
            ;;
	  xdefault) dnl -- default
            ldas_prog_cxx_optimization=$ldas_prog_cxx_optimization_default
            ;;
          *) dnl -- all other cases
	    ldas_prog_cxx_optimization=$ldas_prog_cxx_optimization_medium
	    ;;
	  esac
	  ;;
	esac
])

dnl----------------------------------------------------------------------
dnl Check for ldas packages
dnl AC_LDAS_CHECK_PACKAGE(SourceDir,LaFileName,[InstallDir])
dnl----------------------------------------------------------------------

AC_DEFUN([LDAS_CHECK_PACKAGE],
[
  if test -d ${ldas_top}/$1
  then
    ac_ldas_check_package_inc='[$][(]ldas_top_builddir[)]/include [$][(]ldas_top_builddir[)]/$1';
    ac_ldas_check_package_lib='[$][(]ldas_top_builddir[)]/$1/$2';
  elif test -d ${prefix}/include/$3 && test -d ${prefix}/lib/$3
  then
    ac_ldas_check_package_inc=${prefix}/include;
    ac_ldas_check_package_lib=${prefix}/lib/$3/$2;
  else
    ac_ldas_check_package_inc="";
    ac_ldas_check_package_lib="";
  fi
  #----------------------------------------------------------------------
  # Check to see if the package is available
  #----------------------------------------------------------------------
  define([ldas_tmp_var],dnl
	 patsubst(translit(patsubst($2,[^lib],[]),[A-Z],[a-z]),[[.]],[_]))
  if test -n "${ac_ldas_check_package_inc}" \
	&& test -n "${ac_ldas_check_package_lib}"
  then
    AC_LDAS_PREFIX_INCLUDE_PATH(${ac_ldas_check_package_inc})
    ldas_tmp_var=${ac_ldas_check_package_lib}
    AC_SUBST(ldas_tmp_var)
  fi
  undefine([ldas_tmp_var])
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_DBACCESS],
[ LDAS_CHECK_PACKAGE(lib/dbaccess/src,libdbaccess.la)
  AM_CONDITIONAL(HAVE_PACKAGE_DBACCESS, test x$dbaccess_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_FILTERS],
[ LDAS_CHECK_PACKAGE(lib/filters/src,libfilters.la)
  AM_CONDITIONAL(HAVE_PACKAGE_FILTERS, test x$filters_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_FRAMECPP],
[ LDAS_CHECK_PACKAGE(lib/framecpp/src,libframecpp.la)
  AM_CONDITIONAL(HAVE_PACKAGE_FRAMECPP, test x$framecpp_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_GENERAL],
[ LDAS_CHECK_PACKAGE(lib/general/src,libgeneral.la)
  AM_CONDITIONAL(HAVE_PACKAGE_GENERAL, test x$general_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_ILWD],
[ LDAS_CHECK_PACKAGE(lib/ilwd/src,libilwd.la)
  AM_CONDITIONAL(HAVE_PACKAGE_ILWD, test x$ilwd_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_ILWDFCS],
[ LDAS_CHECK_PACKAGE(lib/ilwdfcs/src,libilwdfcs.la)
  AM_CONDITIONAL(HAVE_PACKAGE_ILWDFCS, test x$ilwdfcs_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_MIME],
[ LDAS_CHECK_PACKAGE(lib/mime/src,libmime.la)
  AM_CONDITIONAL(HAVE_PACKAGE_MIME, test x$mime_la != x)
])

AC_DEFUN([AC_LDAS_CHECK_PACKAGE_GENERIC_API],
[ LDAS_CHECK_PACKAGE(api/genericAPI/so/src,libgenericAPI.la,genericAPI)
  AM_CONDITIONAL(HAVE_PACKAGE_GENERICAPI, test x$genericapi_la != x)
  LDAS_CHECK_PACKAGE(api/genericAPI/so/src,libApiCommon.la)
  AM_CONDITIONAL(HAVE_PACKAGE_API_COMMON, test x$apicommon_la != x)
  LDAS_CHECK_PACKAGE(api/genericAPI/so/src,libApiCommonNS.la)
  AM_CONDITIONAL(HAVE_PACKAGE_API_COMMON_NS, test x$apicommonns_la != x)
  LDAS_CHECK_PACKAGE(api/genericAPI/so/src,libStat.la)
  AM_CONDITIONAL(HAVE_PACKAGE_STAT, test x$Stat_la != x)
  LDAS_CHECK_PACKAGE(api/genericAPI/so/src,libtcltid.la)
  AM_CONDITIONAL(HAVE_PACKAGE_TCL_TID, test x$tcltid_la != x)
])

dnl----------------------------------------------------------------------
dnl Check to see if ospace is available -
dnl variable:
dnl	$1 - a value other than "no" causes aborting of the configuration
dnl		process. A value of "no" indicates that Object Space is
dnl		an optional library.
dnl----------------------------------------------------------------------

AC_DEFUN([AC_LDAS_CHECK_LIB_OSPACE],
[AC_CHECK_LIB(socket,connect)
AC_CHECK_LIB(rt,sched_yield)
AC_CHECK_LIB(pthread,pthread_join)
AC_ARG_WITH(
	ospace, 
	[  --with-ospace[=DIR]         ObjectSpace directory],
	[ case x"$with_ospace" in
	  "x"|xno) ;;
	  *)
	    case x$enable_64bit in
	    xyes)
	      if test -f "${with_ospace}/lib/64/libospace${STLDEBUG}.la"
	      then
	        ospace_la="${with_ospace}/lib/64/libospace${STLDEBUG}.la"
	      elif test -f "${with_ospace}/lib64/libospace${STLDEBUG}.la"
	      then
	        ospace_la="${with_ospace}/lib64/libospace${STLDEBUG}.la"
	      else
	        ospace_la="${with_ospace}/lib/libospace${STLDEBUG}.la"
	      fi
	      ;;
	    *)
	      ospace_la="${with_ospace}/lib/libospace${STLDEBUG}.la"
	      ;;
	    esac
	    AC_SUBST(ospace_la)
	    case x$enable_64bit in
	    xyes)
	      if test -f "${with_ospace}/include64/ospace/config2.h"
	      then
	        AC_LDAS_PREFIX_INCLUDE_PATH("${with_ospace}/include64")
	      else
	        AC_LDAS_PREFIX_INCLUDE_PATH("${with_ospace}/include")
	      fi
	      ;;
	    *)
	      AC_LDAS_PREFIX_INCLUDE_PATH("${with_ospace}/include")
	      ;;
	    esac
	    ldas_tmp_cpp_flags_ospace=$CPPFLAGS
	    ldas_tmp_cxx_flags_ospace=$CXXFLAGS
	    CPPFLAGS="$LDAS_DEFS $CPPFLAGS"
	    CXXFLAGS="$LDAS_DEFS $CXXFLAGS"
	    AC_CHECK_HEADERS( 
		[ ospace/config2.h ],
		[ AC_DEFINE( HAVE_LIBOSPACE,1,[Defined if Object Space should be used] ) EXTRA_LIBS="${EXTRA_LIBS} -lospace${STLDEBUG}" ],
	        [  if test -n "$1" && test "$1" = "no"
		   then
			AC_MSG_WARN(Could not find ObjectSpace headers.)
                   else
			AC_MSG_ERROR(Could not find ObjectSpace headers.)
		   fi
	        ])
	    CPPFLAGS="$CPPFLAGS ${ldas_tmp_cpp_flags_ospace}"
	    CXXFLAGS="$CXXFLAGS ${ldas_tmp_cxx_flags_ospace}"
	    ;;
	 esac
	])
	AC_SUBST(EXTRA_LIBS)
  	AM_CONDITIONAL(HAVE_OSPACE,test -n "${ospace_la}")
])

dnl======================================================================
dnl Misc ...
dnl======================================================================

AC_DEFUN([AC_LDAS_LINK_CONFIG],
[ if test ! -f ${ldas_top}/include/$1/"`basename $2`"
  then
    if test ! -d "${ldas_top}/include/$1"
    then
      mkdir -p "${ldas_top}/include/$1"
    fi
    dest=${ldas_top}/include/$1/"`basename $2`"
    if test -f ${dest} -o -d ${dest} -o -h ${dest}
    then
	rm -rf ${dest}
    fi
    ln -s "`pwd`/$2" ${dest}
  fi
  AC_LDAS_PREFIX_INCLUDE_PATH('[$][(]ldas_top_builddir[)]/include')
])

dnl----------------------------------------------------------------------
dnl :TODO: This macro doesn't work
dnl AM_LDAS_VARIABLE_SET(VARIABLE [, ACTION-IF-FOUND
dnl	 [, ACTION-IF-NOT-FOUND]])
dnl----------------------------------------------------------------------

AC_DEFUN([AM_LDAS_VARIABLE_SET],
[ if test -n [$]$1;
  then if [$2]; then "$2"; fi
  else if [$3]; then "$3"; fi])


AC_DEFUN([AC_LDAS_CHECK_LIB],
[ ac_save_LIBS="$LIBS"
  LIBS="$1  $LIBS"
  cat > conftest.$ac_ext <<EOF
#line 2304 "configure"
#include "confdefs.h"

int main() {
$2()
; return 0; }
EOF
  if { (eval echo configure:2311: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
    rm -rf conftest*
    $3
  else
    echo "configure: failed program was:" >&5
    cat conftest.$ac_ext >&5
    rm -rf conftest*
    $4
  fi
  rm -f conftest*
])


dnl ---------------------------------------------------------------------
dnl CUS_PATH_ODBC_DIRECT
dnl ---------------------------------------------------------------------

AC_DEFUN([CUS_PATH_ODBC_DIRECT],
[test -z "$odbc_direct_test_library" && odbc_direct_test_library=iodbc
test -z "$odbc_direct_test_func" && odbc_direct_test_func=SQLAllocEnv
test -z "$odbc_test_include" && odbc_direct_test_include=isql.h
  for ac_dir in		\
    /ldcg/include \
    ; \
  do
    if test -r "$ac_dir/$odbc_direct_test_include"; then
      no_odbc= ac_odbc_includes=$ac_dir;
      break;
    fi
  done

# Check for the libraries.
# See if we find them without any special options.
# Don't add to $LIBS permanently.

ac_save_LIBS="$LIBS"
LIBS="-l$odbc_direct_test_library $LIBS"
# First see if replacing the include by lib works.
for ac_dir in `echo "$ac_odbc_includes" | sed s/include/lib/` \
  /ldcg/lib \
  ; \
do
  for ac_extension in a so sl; do
    if test -r $ac_dir/lib${odbc_direct_test_library}.$ac_extension; then
      no_odbc= ac_odbc_libraries=$ac_dir
      break 2
    fi
  done
done
LIBS=$ac_save_LIBS])

dnl ---------------------------------------------------------------------
dnl AC_LDAS_ODBC_FILES
dnl ---------------------------------------------------------------------

AC_DEFUN([AC_LDAS_ODBC_FILES],
[AC_REQUIRE_CPP()dnl

AC_ARG_WITH(odbc-includes, [  --with-odbc-includes=DIR
                          ODBC include files are in DIR])
if test -z "$with_odbc_includes"; then
  odbc_includes=NONE
else
  odbc_includes=$with_odbc_includes
fi
AC_ARG_WITH(odbc-libraries, [  --with-odbc-libraries=DIR
                          ODBC library files are in DIR])
if test -z "$with_odbc_libraries"; then
  odbc_libraries=NONE
else
  odbc_libraries=$with_odbc_libraries
fi
AC_ARG_WITH(odbc-dm, [  --with-odbc-dm=ODBC_DRIVER_MANAGER
                          Specify the flavor of the ODBC Driver Manager (DB2 or IODBC)])
if test -z "$with_odbc_dm"; then
  odbc_dm=IODBC
else
  odbc_dm=$with_odbc_dm
fi
case ${odbc_dm} in
   DB2)
    ;;
   IODBC)
    ;;
   *)
	AC_MSG_ERROR(Unsupported ODBC Driver Manager \`${odbc_dm}'; --with-odbc-dm option);
	;;
  esac
ODBC_DM=$odbc_dm
AC_SUBST(ODBC_DM)

AC_MSG_CHECKING(for ODBC)
AC_ARG_WITH(odbc, [  --with-odbc             enable ODBC tests])
if test "x$with_odbc" = xno; then
  no_odbc=yes
else
  if test "x$odbc_includes" != xNONE && test "x$odbc_libraries" != xNONE; then
    no_odbc=
  else
    AC_CACHE_VAL(ac_cv_path_odbc,
      [# One or both of these vars are not set, and ther is no cached value.
      no_odbc=yes
      CUS_PATH_ODBC_DIRECT

      if test "$no_odbc" = yes; then
        ac_cv_path_odbc="no_odbc=yes"
      else
        ac_cv_path_odbc="no_odbc= ac_odbc_includes=$ac_odbc_includes ac_odbc_libraries=$ac_odbc_libraries"
      fi
      ])dnl
  fi
  eval "$ac_cv_path_odbc"
fi

if test "$no_odbc" = yes; then
  AC_MSG_RESULT(no)
  if  test "$odbc_dm" = "IODBC" ; then
    AC_MSG_ERROR(ODBC files not found)
  fi
else
  test "x$odbc_includes" = xNONE && odbc_includes=$ac_odbc_includes
  test "x$odbc_libraries" = xNONE && odbc_libraries=$ac_odbc_libraries
  ac_cv_path_odbc="no_odbc= ac_odbc_includes=$odbc_includes ac_odbc_libraries=$odbc_libraries"
  AC_MSG_RESULT([libraries $odbc_libraries, headers $odbc_includes])
fi

if test -n "$odbc_includes"; then
  IODBC_CFLAGS="-DIODBC -I$odbc_includes"
fi
AC_SUBST(IODBC_CFLAGS)
if test -n "$odbc_libraries"; then
  IODBC_LDFLAGS="-Wl,${RPATH},$odbc_libraries -L$odbc_libraries"
  IODBC_LIBS="-liodbc"
fi
AC_SUBST(IODBC_LDFLAGS)
AC_SUBST(IODBC_LIBS)
])

dnl ---------------------------------------------------------------------
dnl CUS_PATH_DB2_DIRECT
dnl ---------------------------------------------------------------------

AC_DEFUN([CUS_PATH_DB2_DIRECT],
[
test -z "$db2_direct_test_func" && db2_direct_test_func=SQLAllocEnv
test -z "$db2_test_include" && db2_direct_test_include=sqlcli.h
inc_dir="include"
lib_dir="lib"
db2_root_dirs="\
    /ldcg \
    /ldcg/IBMdb2 \
    /opt/IBMdb2/V6.1 \
    /opt/IBMdb2/V5.0"

  for dir in $db2_root_dirs
  do
    if test x$enable_64bit = xyes \
      -a -r "$dir/${inc_dir}64/$db2_direct_test_include"
    then
      no_db2= ac_db2_includes=$dir/${inc_dir}64;
      break
    fi
    if test -r "$dir/$inc_dir/$db2_direct_test_include"
    then
      no_db2= ac_db2_includes=$dir/$inc_dir;
      break
    fi
  done

# Check for the libraries.
# See if we find them without any special options.
# Don't add to $LIBS permanently.

ac_save_LIBS="$LIBS"
# First see if replacing the include by lib works.
for dir in `echo "$ac_db2_includes" | sed s,/$inc_dir,,` $db2_root_dirs
do
  case ${dir} in
  */V5.0)
    db2_direct_test_library="odbc"
    ;;
  *)
    db2_direct_test_library="db2"
    ;;
  esac
  LIBS=${ac_save_LIBS}
  LIBS="-l$db2_direct_test_library $LIBS"
  for ac_extension in a so sl; do
    if test x$enable_64bit = xyes \
	-a -r $dir/${lib_dir}64/lib${db2_direct_test_library}.$ac_extension
    then
      no_db2= ac_db2_libraries=$dir/${lib_dir}64
      break 2
    fi
    if test -r $dir/$lib_dir/lib${db2_direct_test_library}.$ac_extension
    then
      no_db2= ac_db2_libraries=$dir/$lib_dir
      break 2
    fi
  done
done
LIBS=$ac_save_LIBS])

dnl ---------------------------------------------------------------------
dnl AC_LDAS_DB2_FILES
dnl ---------------------------------------------------------------------

AC_DEFUN([AC_LDAS_DB2_FILES],
[AC_REQUIRE_CPP()dnl

AC_ARG_WITH(db2-includes, [  --with-db2-includes=DIR DB2 include files are in DIR])
if test -z "$with_db2_includes"; then
  db2_includes=NONE
else
  db2_includes=$with_db2_includes
fi
AC_ARG_WITH(db2-libraries, [  --with-db2-libraries=DIR
                          DB2 library files are in DIR])
if test -z "$with_db2_libraries"; then
  db2_libraries=NONE
else
  db2_libraries=$with_db2_libraries
fi

AC_MSG_CHECKING(for DB2)
AC_ARG_WITH(db2, [  --with-db2              enable DB2 tests])
if test "x$with_db2" = xno; then
  no_db2=yes
else
  if test "x$db2_includes" != xNONE && test "x$db2_libraries" != xNONE; then
    no_db2=
  else
    AC_CACHE_VAL(ac_cv_path_db2,
      [# One or both of these vars are not set, and ther is no cached value.
      no_db2=yes
      CUS_PATH_DB2_DIRECT

      if test "$no_db2" = yes; then
        ac_cv_path_db2="no_db2=yes"
      else
        ac_cv_path_db2="no_db2= ac_db2_includes=$ac_db2_includes ac_db2_libraries=$ac_db2_libraries"
      fi
      ])dnl
  fi
  eval "$ac_cv_path_db2"
fi

if test "$no_db2" = yes; then
  AC_MSG_RESULT(no)
  if  test "$odbc_dm" = "DB2" ; then
    AC_MSG_ERROR(DB2 files not found)
  fi
else
  test "x$db2_includes" = xNONE && db2_includes=$ac_db2_includes
  test "x$db2_libraries" = xNONE && db2_libraries=$ac_db2_libraries
  ac_cv_path_db2="no_db2= ac_db2_includes=$db2_includes ac_db2_libraries=$db2_libraries"
  AC_MSG_RESULT([libraries $db2_libraries, headers $db2_includes])
fi

if test -n "$db2_includes"; then
  DB2_CFLAGS="-DDB2 -I$db2_includes"
fi
AC_SUBST(DB2_CFLAGS)
if test -n "$db2_libraries"
then
  DB2_LDFLAGS="-Wl,${RPATH},$db2_libraries -L$db2_libraries"
  case "${DB2_LDFLAGS}" in
  */V5.0/*)
    DB2_LIBS="-lodbc -lodbcinst"
    ;;
  *)
    DB2_LIBS="-ldb2"
    ;;
  esac
fi
if test "x$db2_libraries" = xNONE; then
      DB2_LIBS_DIR=
else
      DB2_LIBS_DIR=$db2_libraries
fi
AC_SUBST(DB2_LIBS_DIR)
AC_SUBST(DB2_LDFLAGS)
AC_SUBST(DB2_LIBS)
])


dnl ---------------------------------------------------------------------
dnl AC_LDAS_DATABASE_FILES
dnl ---------------------------------------------------------------------

AC_DEFUN([AC_LDAS_DATABASE_FILES],
[
  AC_ARG_ENABLE(metadata-api,[  --enable-metadata-api[=yes]
                          build the metadata API],
  [enable_metadata="no"], enable_metadata="yes")
  case "${enable_metadata}" in
    no)
	AC_SUBST(DB2_LIBS_DIR)
	AC_SUBST(DB2_LDFLAGS)
	AC_SUBST(DB2_LIBS)
	;;
    *)	AC_LDAS_ODBC_FILES
	AC_LDAS_DB2_FILES
	;;
  esac
])


dnl =====================================================================
dnl   General routine for searching out supported languages
dnl =====================================================================
AC_DEFUN([LDAS_PACKAGE_LANGUAGE],
[
  AC_ARG_WITH([$1],[  --with-$1=<dir>  Directory where $1 is installed],
    [
    ],
    [
      dnl ---------------------------------------------------------------
      dnl  Determine subdir base on file type
      dnl ---------------------------------------------------------------
      case $3 in
      *.h) subdir=include;;
      esac
      dnl ---------------------------------------------------------------
      dnl  Making an educated guess as to where Language is installed
      dnl ---------------------------------------------------------------
      for path in `echo $PATH | \
	  sed -e 's/s*bin:/'$subdir':/g' -e 's/:/ /g' -e 's/s*bin$/'$subdir'/'`
      do
	if test $2 $path/$3
	then
	  with_$1="$path"
	  break
        fi
      done
    ])
  AC_MSG_CHECKING(for $1 installation)
  case x${with_$1} in
  x|xno)
    AC_MSG_RESULT(no)
    with_$1="" # Normalize the result
    ;;
  *)
    if test $2 ${with_$1}/$3
    then
      AC_MSG_RESULT(${with_$1})
      AC_DEFINE(translit(HAVE_$1,[a-z],[A-Z]),dnl
	        [1],dnl
                [Defined if the scripting language $1 is supported])
    else
      AC_MSG_ERROR([no (${with_$1})])
    fi
    ;;
  esac
])
dnl =====================================================================
dnl  Look for TCL scripting language support
dnl =====================================================================
AC_DEFUN([LDAS_PACKAGE_TCL],
[
  AC_PATH_PROG( TCLSH, tclsh )
  AC_PATH_PROG( WISH, wish )
  AC_ARG_WITH([tcl-config],[  --with-tcl-config=<file>  Fully pathed location of the TCL configuration file],
    [],
    [
      dnl ---------------------------------------------------------------
      dnl  Base the educated guess on where the tcl executable was
      dnl    located.
      dnl ---------------------------------------------------------------
      path="`echo $TCLSH | sed -e 's,bin/.*$,lib,g'`"
      if test ! -f "$path/tclConfig.sh"
      then
        dnl -------------------------------------------------------------
        dnl  Need to see the tclConfig.sh file is in a subdirectory.
        dnl -------------------------------------------------------------
	path="$path/tcl`echo '$tcl_version' | $TCLSH`"
      fi
      if test -f "$path/tclConfig.sh"
      then
        with_tcl_config=$path/tclConfig.sh
      fi
    ])
  AM_CONDITIONAL(HAVE_TCL,test -f "${with_tcl_config}")
  AC_MSG_CHECKING(for tcl)
  if test -f "${with_tcl_config}"
  then
    AC_MSG_RESULT(yes)
    dnl -----------------------------------------------------------------
    dnl  import the configuration file
    dnl -----------------------------------------------------------------
    . "${with_tcl_config}"
    dnl -----------------------------------------------------------------
    dnl  export those variables that will be needed
    dnl -----------------------------------------------------------------
    AC_SUBST(TCL_INCLUDE_SPEC)
    AC_SUBST(TCL_LIB_SPEC)
    AC_SUBST(TCL_STUB_SPEC)
    AC_SUBST(TCL_VERSION)
    AC_MSG_CHECKING(for tcl version)
    AC_MSG_RESULT($TCL_VERSION)
    dnl -----------------------------------------------------------------
    dnl  Define for building extensions
    dnl -----------------------------------------------------------------
    AC_DEFINE([HAVE_TCL],dnl
	      [1],dnl
              [Defined if the scripting language TCL is supported])
  else
    AC_MSG_RESULT(no)
  fi
])
dnl =====================================================================
dnl  Look for Python scripting language support
dnl =====================================================================
AC_DEFUN([LDAS_PACKAGE_PYTHON],
[
  AC_PATH_PROG( PYTHON, python )
  AC_PATH_PROG( PYTHON_CONFIG, python-config )
  AC_ARG_ENABLE([python],
    [ --disable-python  Disable the use of python],
    [],
    [ unset PYTHON
      unset PYTHON_CONFIG ] )
  if ! test -f "$PYTHON"
  then
    unset PYTHON
  fi
  case x${PYTHON} in
  x)
    unset PYTHON
    ;;
  *)
    dnl -----------------------------------------------------------------
    dnl  Figure out which version of python is installed
    dnl -----------------------------------------------------------------
    PYTHON_VERSION="`${PYTHON} -V 2>&1 | \
      sed 's,^Python \([[0-9]][[0-9]]*\(\.[[0-9]][[0-9]]*\)*\).*$,\1,gi' | \
      sed 's,^\([[0-9]][[0-9]]*\(\.[[0-9]][[0-9]]*\)\).*$,\1,gi'`"
    case x$PYTHON_CONFIG in
    x)
	dnl -------------------------------------------------------------
	dnl Get the information the hard way
	dnl -------------------------------------------------------------
        PYTHON_INCLUDES="-I`echo ${PYTHON} | \
	  sed 's,/python$,,g' | \
	  sed 's,/amd64,64,g' | \
	  sed 's,/64,64,g' | \
	  sed 's,/bin\([[^/]]*\),/include\1,g'`/python$PYTHON_VERSION";
	;;
    *)
	dnl -------------------------------------------------------------
	dnl Newer version of python have the python-config script
	dnl -------------------------------------------------------------
    	PYTHON_INCLUDES="`$PYTHON_CONFIG --includes`"
	;;
    esac
    AC_SUBST(PYTHON_VERSION)
    AC_SUBST(PYTHON_INCLUDES)
    AC_SUBST(PYTHON)
  esac
  AC_MSG_CHECKING(for python headers)
  AM_CONDITIONAL(HAVE_PYTHON,test -n "${PYTHON_INCLUDES}")
])

AC_DEFUN([AC_LDAS_VAR_APPEND],[
  case "$2" in
  -*) opt="";;
  *)
    case $1 in
    *LDFLAGS) opt="-L" ;;
    *CXXFLAGS|*CFLAGS) opt="-I" ;;
    *) opt="";;
    esac
    ;;
  esac
  case x$3 in
  x) ;;
  xLITERAL) opt="" ;;
  *) opt="$3" ;;
  esac
  opt="${opt}$2"
  st="[[ |	]]";
  echo "[$]$1" |  egrep "^${opt}${st}|${st}${opt}${st}|${st}$opt[$]|^${opt}[$]"
  if test $? -ne 0
  then
    $1="[$]$1 ${opt}"
  fi
])

AC_DEFUN([AC_LDAS_VAR_PREPEND],[
  case "$2" in
  -*) opt="";;
  *)
    case $1 in
    *LDFLAGS) opt="-L" ;;
    *CXXFLAGS|*CFLAGS) opt="-I" ;;
    *) opt="";;
    esac
    ;;
  esac
  case x$3 in
  x) ;;
  xLITERAL) opt="" ;;
  *) opt="$3"
  esac
  opt="${opt}$2"
  st="[[ |	]]";
  echo "[$]$1" |  egrep "^${opt}${st}|${st}${opt}${st}|${st}${opt}\\[$]|^${opt}\\[$]"
  if test $? -ne 0
  then
    $1="[$]$1 ${opt}"
  fi
])

AC_DEFUN([AC_LDAS_VAR_APPEND_COND],[
  if test $1
  then
    AC_LDAS_VAR_APPEND($2,$3)
  fi
])

AC_DEFUN([AC_LDAS_VAR_PREPEND_COND],[
  if test $1
  then
    AC_LDAS_VAR_PREPEND($2,$3)
  fi
])


dnl ---------------------------------------------------------------------
dnl  Check for Support of md5sum calculations
dnl ---------------------------------------------------------------------
AC_DEFUN([AC_LDAS_CHECK_LIB_FRAMEL],[
  AC_LANG_SAVE
  AC_LANG_C
  ldas_saved_cflags=$CFLAGS
  ldas_saved_libs=$LIBS
  AC_ARG_WITH([framel],
  [ --with-framel=DIR   Directory where libframe exists],,
  [ for dir in /opt/lscsoft/libframe $prefix `echo $LD_LIBRARY_PATH | sed -e 's/:/ /g'`
    do
      dir="`echo $dir | sed -e 's/\/lib$//'`";
      if test -f "$dir/include/FrameL.h"
      then
        with_framel="$dir"
	break
      fi
    done ])

  case x$with_framel in
  x)
    ;;
  *)
    LIBS="$LIBS -L$with_framel/lib"
    ;;
  esac
  AC_CHECK_LIB(Frame,FrVectCompress,[
    AC_DEFINE(HAVE_LIBFRAME,1,Define to 1 if you have the `Frame' library (-lFrame))
    case x$with_framel in
    x)
      ;;
    *)
      LIBFRAME="-L$with_framel/lib "
      CPPFLAGSFRAME="-I$with_framel/include"
      ;;
    esac
    LIBFRAME="${LIBFRAME}-lFrame"
    LIBS="${lt_prog_compiler_static} ${LIBFRAME} -lm"
    CFLAGS="$CPPFLAGSFRAME $CFLAGS"
    AC_RUN_IFELSE([
	#include "FrameL.h"

	extern int FrSlong;

	int
	main( )
	{
	  FrLibShortIni( );
	  /*
	   * Zero exit (true) if FR_LONG_LONG should be defined
	   * Non-zero (false) if FR_LONG_LONG should not be defined
	   */
	  exit( FrSlong == sizeof( long ) );
	}
    ],[
      AC_DEFINE([DEFINE_FR_LONG_LONG],1,[Define to 1 if FR_LONG_LONG needs to be defined])
    ],[],[])

  ],[],-lm)
  AC_SUBST(LIBFRAME)
  AC_SUBST(CPPFLAGSFRAME)
  AM_CONDITIONAL(HAVE_LIBFRAME, test "x$LIBFRAME" != "x")
  CFLAGS=$ldas_saved_cflags
  LIBS=$ldas_saved_libs
  AC_LANG_RESTORE
])

dnl ---------------------------------------------------------------------
dnl  Check for Support of md5sum calculations
dnl ---------------------------------------------------------------------
AC_DEFUN([LDAS_LIB_MD5SUM],
  [ dnl -----------------------------------------------------------------
    dnl  Check for the library first
    dnl -----------------------------------------------------------------
    case `uname` in
    Linux)

      AC_CHECK_LIB(crypto,MD5_Init,
	[ AC_DEFINE(HAVE_MD5_IN_CRYPTO,1,[Defined if have md5 routines in libcrypto])
	  LIBMD5="-lcrypto"
	  AC_SUBST(LIBMD5)
          AC_CHECK_HEADERS([openssl/md5.h])
	],[ AC_CHECK_LIB(md5,MD5Init,
	    [ AC_DEFINE(HAVE_LIBMD5,1,[Defined if have libmd5])
	      LIBMD5="-lmd5"
	      AC_SUBST(LIBMD5)
	      AC_CHECK_HEADERS([md5.h])
	      AC_CHECK_HEADERS([md5global.h])
            ],[AC_MSG_ERROR(Missing md5 support) ])])
      ;;
    *)
      AC_CHECK_LIB(md5,MD5Init,
	[ AC_DEFINE(HAVE_LIBMD5,1,[Defined if have libmd5])
	  LIBMD5="-lmd5"
	  AC_SUBST(LIBMD5)
	  AC_CHECK_HEADERS([md5.h])
	  AC_CHECK_HEADERS([md5global.h])
	],[ AC_CHECK_LIB(crypto,MD5_Init,
	    [ AC_DEFINE(HAVE_MD5_IN_CRYPTO,1,[Defined if have md5 routines in libcrypto])
	      LIBMD5="-lcrypto"
	      AC_SUBST(LIBMD5)
              AC_CHECK_HEADERS([openssl/md5.h])
            ],[AC_MSG_ERROR(Missing md5 support) ])])
      ;;
    esac
  ])

dnl -------------------------------------------------------------------
dnl -- check for SGI STL library (to use instead of gcc provided one)
dnl -------------------------------------------------------------------
AC_DEFUN([LDAS_LIB_STLPORT],[
  dnl -----------------------------------------------------------------
  dnl --- STLport - Core library
  dnl -----------------------------------------------------------------
  AC_ARG_WITH([stlport],
  [ --with-stlport=DIR   Build with SGI STL library],,
  [ for dir in $prefix `echo $LD_LIBRARY_PATH | sed -e 's/:/ /g'`
    do
      dir="`echo $dir | sed -e 's/\/lib$//'`";
      if test -d "$dir/include/stlport"
      then
        with_stlport="$dir"
	break
      fi
    done ])
  AC_MSG_CHECKING(for stlport installation directory)
  case "x$with_stlport" in
  x|xno)
    AC_MSG_RESULT(none)
    ;;
  *)
    if test -d "$dir"/include/stlport
    then
      with_stlport="$dir"
      AC_MSG_RESULT($with_stlport/include/stlport)
      STLPORT_INCLUDE_DIR="$with_stlport/include/stlport"
      STLPORT_LIB_DIR="$with_stlport/lib"
      if test -e $STLPORT_LIB_DIR/libstlport_gcc.so
      then
        STLPORT_LIB="stlport_gcc"
        STLPORT_DEBUG_LIB="stlport_gcc_stldbg"
      else
        STLPORT_LIB="stlport"
        STLPORT_DEBUG_LIB="stlportg"
      fi
      STLPORT_DEBUG_CXXFLAGS="-D_STLP_DEBUG -D_STLP_DEBUG_ALLOC -D_STLP_DEBUG_UNINITIALIZED"
    else
      AC_MSG_ERROR( invalid stlport directory: $with_stlport )
    fi
    ;;
  esac
  dnl -------------------------------------------------------------------
  dnl -- check for debug STLport library
  dnl -------------------------------------------------------------------
  AC_ARG_ENABLE(stlport-debug,
  [ --enable-stlport-debug   Build with debug STL library],
  [enable_stlport_debug=yes],
  [enable_stlport_debug=no])
  dnl -------------------------------------------------------------------
  dnl -- Establish shell variable to know if using the debug version
  dnl -------------------------------------------------------------------
  case x"${with_stlport}" in
  x|xno)
    dnl -----------------------------------------------------------------
    dnl -- Either the installation directory was invalid or the user
    dnl --   specifically requested not to use STLport
    dnl -----------------------------------------------------------------
    ;;
  *)
    dnl -----------------------------------------------------------------
    dnl -- Want to use STLport
    dnl -----------------------------------------------------------------
    AC_MSG_CHECKING(for stlport debug)
    case x"${enable_stlport_debug}" in
    xyes)
      AC_MSG_RESULT(yes)
      case "${STLPORT_DEBUG_LIB}" in
        stlport_dbg)
        STLDEBUG="_dbg"
        ;;
      stlport_*_stldbg)
        STLDEBUG="_stldbg"
        ;;
      esac
      ;;
    *)
      dnl ---------------------------------------------------------------
      dnl Use non-debug version of stlport
      dnl ---------------------------------------------------------------
      AC_MSG_RESULT(no)
      ;;
    esac # x"${enable_stlport_debug}"
  esac # x"${enable_stlport}"
  dnl '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  dnl Set some compiler specific options
  dnl '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  if test "$ldas_prog_cxx_vendor" = Sun
  then
    if test -z "$STLPORT_LIB"
    then
      CXXFLAGS="$CXXFLAGS -library=stlport4"
    else
      CXXFLAGS="$CXXFLAGS -library=no%Cstd"
    fi
  fi
  AC_SUBST(STLDEBUG)
]) dnl LDAS_LIB_STLPORT

dnl ---------------------------------------------------------------------
dnl   Check for Support of STLport Finish
dnl ---------------------------------------------------------------------
AC_DEFUN([LDAS_LIB_STLPORT_FINISH],[
  dnl -------------------------------------------------------------------
  dnl -- Establish compiler/linker flags for STLport
  dnl -------------------------------------------------------------------
  case x"${with_stlport}" in
  x|xno)
    dnl -----------------------------------------------------------------
    dnl -- Either the installation directory was invalid or the user
    dnl --   specifically requested not to use STLport
    dnl -----------------------------------------------------------------
    ;;
  *)
    dnl -----------------------------------------------------------------
    dnl -- Want to use STLport
    dnl -----------------------------------------------------------------
    case x"${enable_stlport_debug}" in
    xyes)
      debug_flags="$STLPORT_DEBUG_CXXFLAGS"
      stlport_lib="STLPORT_DEBUG_LIB";
      ;;
    *)
      dnl ---------------------------------------------------------------
      dnl Use non-debug version of stlport
      dnl ---------------------------------------------------------------
      stlport_lib="$STLPORT_LIB";
      ;;
    esac # x"${enable_stlport_debug}"
    case x${STLPORT_CXXFLAGS} in
    x) ;;
    *) AC_MSG_CHECKING(for stlport CXXFLAGS)
       CXXFLAGS="${CXXFLAGS} ${STLPORT_CXXFLAGS}"
       AC_MSG_RESULT(${STLPORT_CXXFLAGS})
       ;;
    esac
    case x${STLPORT_INCLUDE_DIR} in
    x) ;;
    *) AC_MSG_CHECKING(for stlport include flags)
       CXXFLAGS="${CXXFLAGS} -I${STLPORT_INCLUDE_DIR} $debug_flags"
       AC_MSG_RESULT(-I${STLPORT_INCLUDE_DIR} $debug_flags)
       ;;
    esac
    case x${STLPORT_LIB_DIR} in
    x)
       case x${stlport_lib} in
       x)
 	 ;;
       *)
         STLPORT_LDFLAGS="-l${stlport_lib}"
         ;;
       esac
       ;;
    *)
       STLPORT_LDFLAGS="${LDFLAGS} -L${STLPORT_LIB_DIR} -l${stlport_lib}"
       ;;
    esac
    case x$STLPORT_LDFLAGS in
    x) ;;
    *) AC_MSG_CHECKING(for stlport LDFLAGS)
       LDFLAGS="${LDFLAGS} ${STLPORT_LDFLAGS}"
       AC_MSG_RESULT(${STLPORT_LDFLAGS})
       ;;
    esac
    ;;
  esac # x"${enable_stlport}"
])
dnl ---------------------------------------------------------------------
dnl  Check for Support of md5sum calculations
dnl ---------------------------------------------------------------------
AC_DEFUN([LDAS_LIB_UMEM],
[
  dnl -------------------------------------------------------------------
  dnl  Detect if the OS supplies a version of libumem
  dnl -------------------------------------------------------------------
  case x$enable_64bit in
  xyes)
    for x in 64 \
	sparcv9
    do
      if test -f /usr/lib/$x/libumem.so -o -L /usr/lib/$x/libumem.so
      then
        LIBUMEM=/usr/lib/$x/libumem.so
	break
      fi
    done
    ;;
  *)
    if test -f /usr/lib/libumem.so -o -L /usr/lib/libumem.so
    then
      LIBUMEM=/usr/lib/libumem.so
    fi
    ;;
  esac
  AC_SUBST(LIBUMEM)
])

dnl -*- m4 -*-
dnl----------------------------------------------------------------------
dnl These are custom rules for certain programs
dnl----------------------------------------------------------------------
dnl======================================================================
dnl LDAS_PROG_BISON
dnl   Check on how to setup bison
dnl Depends:
dnl======================================================================
AC_DEFUN([LDAS_PROG_BISON],
[ AC_PROG_YACC
  case "$YACC" in
  bison\ *) YACC="bison --debug --locations";;
  esac
])

dnl======================================================================
dnl AC_LDAS_PROG_CC
dnl   Check on how to setup cc
dnl Depends:
dnl======================================================================

AC_DEFUN([AC_LDAS_PROG_CC],
[ AC_PROG_CC
  if test x${ac_cv_prog_cc_g} = xyes
  then
    dnl------------------------------------------------------------------
    dnl PR3112: Put in -g (debug) option if supported by compiler
    dnl------------------------------------------------------------------
    CFLAGS="-g $CFLAGS"
  fi
  if test "${GCC}" = "yes"
  then
    touch ,t.c
    ac_ldas_default_cc_includes="`${CC} -v ,t.c 2>&1 | \
  	sed -n -e '/\#include/,/End of search list\./p' | \
  	egrep '^ '`"
    rm ,t.c
  fi
  #=======================================================================
  # Determine compiler vendor
  #=======================================================================
  AC_LANG_SAVE
  AC_LANG_C
  LDAS_CC_FLAVOR="generic"
  ldas_prog_cc_vendor=generic
  if test $ldas_prog_cc_vendor = generic
  then
    dnl -----------------------------------------------------------------
    dnl  Checking if GNU flavor
    dnl -----------------------------------------------------------------
    if test "${GCC}" = yes
    then
      ldas_prog_cc_vendor="GNU"
      LDAS_CC_FLAVOR=gnu
    fi
  fi
  if test $ldas_prog_cc_vendor = generic
  then
    dnl -----------------------------------------------------------------
    dnl  Checking if SunPRO flavor
    dnl -----------------------------------------------------------------
    AC_TRY_RUN([ #include <stdlib.h>

                 int main( );

                 int
                 main( )
                 {
                   #if __SUNPRO_C
                   exit( 0 );
                   #endif /* __SUNPRO_C */
	           exit( 1 );
                 }
               ],[
                ldas_prog_cc_vendor=Sun
        	LDAS_CC_FLAVOR="SunPRO"
               ])
  fi
  AC_LANG_RESTORE
  AM_CONDITIONAL([LDAS_CC_SUNPRO],[test x$LDAS_CC_FLAVOR = xSunPRO])
  dnl -------------------------------------------------------------------
  dnl  setting up of compiler flags
  dnl -------------------------------------------------------------------
  AC_MSG_CHECKING(C vendor)
  AC_MSG_RESULT($ldas_prog_cc_vendor)
  case x$ldas_prog_cc_vendor in
  xGNU) dnl ######## G N U ########
    dnl -----------------------------------------------------------------
    dnl  Optimization
    dnl -----------------------------------------------------------------
    ldas_prog_cc_optimization_key="-O"
    ldas_prog_cc_optimization_none="-O0"
    ldas_prog_cc_optimization_exrtreme="-O4"
    ldas_prog_cc_optimization_high="-O3"
    ldas_prog_cc_optimization_medium="-O2"
    ldas_prog_cc_optimization_low="-O1"
    ldas_prog_cc_optimization_default=""
    dnl -----------------------------------------------------------------
    dnl   64 bit
    dnl -----------------------------------------------------------------
    case $ldas_processor in
    sparc)
      ldas_prog_cc_64bit="-m64 -mcpu=v9"
      ;;
    *)
      ldas_prog_cc_64bit="-m64"
      ;;
    esac
    dnl -----------------------------------------------------------------
    dnl  Handling of warnings
    dnl -----------------------------------------------------------------
    ldas_prog_cc_warning="-Wall"
    ldas_prog_cc_warning_as_error="-Werror"
    ;;
  xSun) dnl ######## S U N   S T U D I O ########
    dnl -----------------------------------------------------------------
    dnl  Optimization
    dnl -----------------------------------------------------------------
    ldas_prog_cc_optimization_key="-O"
    ldas_prog_cc_optimization_none="-xO0"
    ldas_prog_cc_optimization_exrtreme="-xO5"
    ldas_prog_cc_optimization_high="-xO4"
    ldas_prog_cc_optimization_medium="-xO3"
    ldas_prog_cc_optimization_low="-xO1"
    ldas_prog_cc_optimization_default=""
    dnl -----------------------------------------------------------------
    dnl   64 bit
    dnl -----------------------------------------------------------------
    ldas_prog_cc_64bit="-xarch=generic64"
    dnl -----------------------------------------------------------------
    dnl  Handling of warnings
    dnl -----------------------------------------------------------------
    ldas_prog_cc_warning=""
    ldas_prog_cc_warning_as_error="-errwarn=%all"
    ;;
  *) dnl ###### D E F A U L T ########
    dnl -----------------------------------------------------------------
    dnl  Optimization
    dnl -----------------------------------------------------------------
    ldas_prog_cc_optimization_key="-O"
    ldas_prog_cc_optimization_none="-O0"
    ldas_prog_cc_optimization_exrtreme="-O4"
    ldas_prog_cc_optimization_high="-O3"
    ldas_prog_cc_optimization_medium="-O2"
    ldas_prog_cc_optimization_low="-O1"
    ldas_prog_cc_optimization_default=""
    ;;
  esac
  dnl -------------------------------------------------------------------
  dnl Setup flags for 64 bit compilation
  dnl -------------------------------------------------------------------
  AC_REQUIRE([AC_LDAS_ARG_ENABLE_64BIT])
  case x${enable_64bit} in
  xyes)
    CFLAGS="$CFLAGS $ldas_prog_cc_64bit"
    ;;
  esac
  dnl -------------------------------------------------------------------
  dnl  Checking on how to pass rpath info
  dnl -------------------------------------------------------------------
  saved_LDFLAGS="$LDFLAGS"
  LDFLAGS="$LDFLAGS -Wl,--rpath,/usr/lib"
  AC_TRY_RUN([ #include <stdlib.h>

               int main( );

               int
               main( )
               {
                   exit( 0 );
               }
             ],[
	        RPATH="--rpath"
             ])
  LDFLAGS="$saved_LDFLAGS"
  case "$RPATH" in
  "")
    saved_LDFLAGS="$LDFLAGS"
    LDFLAGS="$LDFLAGS -Wl,-R,/usr/lib"
    AC_TRY_RUN([ #include <stdlib.h>

                 int main( );

                 int
                 main( )
                 {
                   exit( 0 );
                 }
               ],[
	        RPATH="-R"
               ])
    LDFLAGS="$saved_LDFLAGS"
    ;;
  esac
])

dnl======================================================================
dnl AC_LDAS_PROG_CXX
dnl   Check on how to setup c++
dnl Depends:
dnl======================================================================

AC_DEFUN([AC_LDAS_PROG_CXX],
[ AC_PROG_CXX
  if test x${ac_cv_prog_cxx_g} = xyes
  then
    dnl------------------------------------------------------------------
    dnl PR3112: Put in -g (debug) option if supported by compiler
    dnl------------------------------------------------------------------
    CXXFLAGS="-g $CXXFLAGS"
  fi
  if test "${GXX}" = "yes"
  then
    touch ,t.cc
    ac_default_cxx_includes="`${CXX} -v ,t.cc 2>&1 | \
  	sed -n -e '/\#include/,/End of search list\./p' | \
  	egrep '^ '`"
    rm ,t.cc
  fi
  #=======================================================================
  # Determine compiler vendor
  #=======================================================================
  AC_LANG_SAVE
  AC_LANG_CPLUSPLUS
  LDAS_CXX_FLAVOR="generic"
  ldas_prog_cxx_vendor=generic
  if test $ldas_prog_cxx_vendor = generic
  then
    dnl -----------------------------------------------------------------
    dnl  Checking if GNU flavor
    dnl -----------------------------------------------------------------
    if test "${GXX}" = yes
    then
      ldas_prog_cxx_vendor="GNU"
      LDAS_CXX_FLAVOR=gnu
    fi
  fi
  if test $ldas_prog_cxx_vendor = generic
  then
    dnl -----------------------------------------------------------------
    dnl  Checking if SunPRO flavor
    dnl -----------------------------------------------------------------
    AC_TRY_RUN([ #include <stdlib.h>

                 int main( );

                 int
                 main( )
                 {
                   #if __SUNPRO_CC
                   exit( 0 );
                   #endif /* __SUNPRO_CC */
	           exit( 1 );
                 }
               ],[
                ldas_prog_cxx_vendor=Sun
        	LDAS_CXX_FLAVOR="SunPRO"
               ])
  fi
  AC_LANG_RESTORE
  dnl -------------------------------------------------------------------
  dnl  setting up of compiler flags
  dnl -------------------------------------------------------------------
  AC_MSG_CHECKING(C++ vendor)
  AC_MSG_RESULT($ldas_prog_cxx_vendor)
  case x$ldas_prog_cxx_vendor in
  xGNU) dnl ######## G N U ########
    dnl -----------------------------------------------------------------
    dnl  Optimization
    dnl -----------------------------------------------------------------
    ldas_prog_cxx_optimization_key="-O"
    ldas_prog_cxx_optimization_none="-O0"
    ldas_prog_cxx_optimization_exrtreme="-O4"
    ldas_prog_cxx_optimization_high="-O3"
    ldas_prog_cxx_optimization_medium="-O2"
    ldas_prog_cxx_optimization_low="-O1"
    ldas_prog_cxx_optimization_default=""
    dnl -----------------------------------------------------------------
    dnl   64 bit
    dnl -----------------------------------------------------------------
    case $ldas_processor in
    sparc)
      ldas_prog_cxx_64bit="-m64 -mcpu=v9"
      ;;
    *)
      ldas_prog_cxx_64bit="-m64"
      ;;
    esac
    dnl -----------------------------------------------------------------
    dnl  Handling of warnings
    dnl -----------------------------------------------------------------
    ldas_prog_cxx_warning="-Wall"
    ldas_prog_cxx_warning_as_error="-Werror"
    ;;
  xSun) dnl ######## S U N   S T U D I O ########
    dnl -----------------------------------------------------------------
    dnl  Optimization
    dnl -----------------------------------------------------------------
    ldas_prog_cxx_optimization_key="-O"
    ldas_prog_cxx_optimization_none="-xO0"
    ldas_prog_cxx_optimization_exrtreme="-xO4"
    ldas_prog_cxx_optimization_high="-xO3"
    ldas_prog_cxx_optimization_medium="-xO2"
    ldas_prog_cxx_optimization_low="-xO1"
    ldas_prog_cxx_optimization_default=""
    dnl -----------------------------------------------------------------
    dnl   64 bit
    dnl -----------------------------------------------------------------
    ldas_prog_cxx_64bit="-m64"
    dnl -----------------------------------------------------------------
    dnl  Handling of warnings
    dnl -----------------------------------------------------------------
    ldas_prog_cxx_warning=""
    ldas_prog_cxx_warning_as_error="-errwarn=%all"
    dnl -----------------------------------------------------------------
    dnl  Setting up of CXXFLAGS
    dnl -----------------------------------------------------------------
    dnl Use STLport, not default
    CXXFLAGS="$CXXFLAGS -library=stlport4"
    dnl AC_CHECK_LIB([sunmath],[coshf])
    dnl -----------------------------------------------------------------
    dnl  Checking Version of Sun Studio compiler
    dnl -----------------------------------------------------------------
    AC_LANG_SAVE
    AC_LANG_CPLUSPLUS
    AC_TRY_RUN([ #include <stdlib.h>

                 int main( );

                 int
                 main( )
                 {
                   #if __SUNPRO_CC <= 0x0590
                   exit( 0 );
                   #endif /* __SUNPRO_CC */
	           exit( 1 );
                 }
               ],[ldas_inline_kludge="inline"
               ])
    AC_LANG_RESTORE
    ;;
  *) dnl ###### D E F A U L T ########
    dnl -----------------------------------------------------------------
    dnl  Optimization
    dnl -----------------------------------------------------------------
    ldas_prog_cxx_optimization_key="-O"
    ldas_prog_cxx_optimization_none="-O0"
    ldas_prog_cxx_optimization_exrtreme="-O4"
    ldas_prog_cxx_optimization_high="-O3"
    ldas_prog_cxx_optimization_medium="-O2"
    ldas_prog_cxx_optimization_low="-O1"
    ldas_prog_cxx_optimization_default=""
    ;;
  esac
  AM_CONDITIONAL([LDAS_CXX_SUNPRO],[test x$LDAS_CXX_FLAVOR = xSunPRO])

  dnl -------------------------------------------------------------------
  dnl Setup flags for 64 bit compilation
  dnl -------------------------------------------------------------------
  AC_REQUIRE([AC_LDAS_ARG_ENABLE_64BIT])
  case x${enable_64bit} in
  xyes)
    CXXFLAGS="$CXXFLAGS $ldas_prog_cxx_64bit"
    ;;
  esac
  AC_DEFINE_UNQUOTED([INLINE_KLUDGE],${ldas_inline_kludge},Set to "inline" if need to inline kludge to prevent multi/undefined variables)
  dnl -------------------------------------------------------------------
  dnl  Perform all tests using C++
  dnl -------------------------------------------------------------------
  AC_LANG_CPLUSPLUS
])

dnl======================================================================
dnl LDAS_PROG_DOT
dnl======================================================================
AC_DEFUN([LDAS_PROG_DOT],
[ AC_MSG_CHECKING(for dot)
  AC_PATH_PROGS( DOT, dot )
  case x$DOT in
  x) AC_MSG_RESULT(no);;
  *)
    AC_MSG_RESULT($DOT)
    DOT_PATH="`echo $DOT | sed -e 's,/[^/]*$,,'`"
    ;;
  esac
  AC_SUBST(DOT_PATH)
  AM_CONDITIONAL(HAVE_DOT, test x$DOT != x)
])

dnl======================================================================
dnl LDAS_PROG_DOXYGEN
dnl======================================================================
AC_DEFUN([LDAS_PROG_DOXYGEN],
[ AC_REQUIRE([LDAS_PROG_LATEX])
  AC_REQUIRE([LDAS_PROG_DOT])
  AC_ARG_WITH([doxygen],
	[  --with-doxygen=<PATH>  Specify the path for doxygen],
	[],[with_doxygen=doxygen])
  case x"$with_doxygen" in
  x|xno)
    DOXYGEN=""
    ;;
  * )
    AC_MSG_CHECKING(for doxygen)
    AC_PATH_PROGS( DOXYGEN, doxygen )
    case x$DOXYGEN in
    x) AC_MSG_RESULT(no);;
    *) AC_MSG_RESULT($DOXYGEN);;
    esac
  esac
  AM_CONDITIONAL(HAVE_DOXYGEN, test x$DOXYGEN != x)
])

dnl======================================================================
dnl LDAS_PROG_LATEX
dnl======================================================================
AC_DEFUN([LDAS_PROG_LATEX],
[ AC_MSG_CHECKING(for latex)
  AC_PATH_PROGS( LATEX, latex )
  case x$LATEX in
  x) AC_MSG_RESULT(no);;
  *) AC_MSG_RESULT($LATEX);;
  esac
  AM_CONDITIONAL(HAVE_LATEX, test x$LATEX != x)
])

dnl======================================================================
dnl LDAS_PROG_LEX
dnl   Check on how to setup lex
dnl Depends:
dnl======================================================================
AC_DEFUN([LDAS_PROG_LEX],
[ AM_PROG_LEX
  case x$LEX in
  x/*)
    ;;
  *)
    AC_PATH_PROGS(LEX,flex lex)
    ;;
  esac
  case x$LEX in
  */flex|*/flex++)
    dnl------------------------------------------------------------------
    dnl If the version of flex installed on the destination machine
    dnl   is different from what generated the sources, then
    dnl   remove the sources so they will be regenerated.
    dnl------------------------------------------------------------------
    AC_EGREP_CPP([yy_current_buffer],
    [ #include <FlexLexer.h>
    ],
    [ AC_DEFINE([HAVE_YY_CURRENT_BUFFER],1,[Defined if yy_current_buffer is in yyFlexLexer class])
    ],
    [ AC_DEFINE([YY_CURRENT_BUFFER_EQUIV],[(yy_buffer_stack[[yy_buffer_stack_top]])],[Defined as the equivelent fro yy_current_buffer])
    ])
    ;;
  esac
])

dnl======================================================================
dnl AC_LDAS_PROG_LIBTOOL
dnl   Check on how to setup libtool
dnl Depends:
dnl======================================================================

AC_DEFUN([AC_LDAS_PROG_LIBTOOL],
[
  dnl -------------------------------------------------------------------
  dnl Need to ensure the correct usage of the C compiler
  dnl -------------------------------------------------------------------
  AC_REQUIRE([AC_LDAS_PROG_CC])
  dnl -------------------------------------------------------------------
  dnl This hack is needed until libtool 1.5.22 is out. It will properly
  dnl    configure for 64bit Solaris.
  dnl -------------------------------------------------------------------
  ac_save_CC=$CC
  ac_save_CXX=$CXX
  CC="$CC $CFLAGS"
  CXX="$CXX $CXXFLAGS"
  AC_LANG_SAVE
  AC_LANG_C
  AM_PROG_LIBTOOL
  AC_LANG_RESTORE
  case "$LDAS_CXX_FLAVOR" in
  SunPRO)
	if echo $CXXFLAGS | grep -e -library=stlport4 > /dev/null 2>&1
	then
		dnl -----------------------------------------------------
		dnl libtool currently assumes the default std C++ library.
		dnl   LDAS requires the stlport4 library instead.
		dnl -----------------------------------------------------
		mv libtool libtool.orig
		sed -e 's/-lCstd -lCrun/-library=stlport4/g' libtool.orig > libtool
		chmod +x libtool
	fi
	;;
  esac
  CC=$ac_save_CC
  CXX=$ac_save_CXX
])

dnl======================================================================
dnl AC_LDAS_PROG_PCE2
dnl   Check on how to setup pce2
dnl======================================================================

AC_DEFUN([AC_LDAS_PROG_PCE2],
[ AC_REQUIRE([LDAS_PROG_DOXYGEN])
  dnl if test x$DOXYGEN = x
  dnl then
    dnl =============================================================
    dnl  Use the much older perceps package only if doxygen is
    dnl    not available.
    dnl =============================================================
    if test -x ${srcdir}/${ldas_top}/lib/perceps/pce2
    then
      PERCEPS='[$][(]ldas_top_srcdir[)]/lib/perceps/pce2'
    elif test -x ${prefix}/bin/pce2
    then
      PERCEPS='[$][(]bindir[)]/pce2'
    fi
    if test -d ${srcdir}/${ldas_top}/lib/perceps
    then
      PERCEPS_ENV='[$][(]ldas_top_srcdir[)]/lib/perceps'
    elif test -d "${prefix}/lib/perceps"
    then
      PERCEPS_ENV='[$][(]libdir[)]/perceps'
    else
      PERCEPS_ENV=""
    fi
  dnl fi
  if test -z "${PERCEPS}" \
	|| test -z "${PERCEPS_ENV}"
  then
    dnl =============================================================
    dnl  Reset variables to be empty since there is no perceps.
    dnl =============================================================
    PERCEPS="";
    PERCEPS_FLAGS=""
    PERCEPS_ENV=""
    HAVE_PERCEPS="no"
  else
    HAVE_PERCEPS="yes"
  fi
  AC_SUBST(PERCEPS)
  AC_SUBST(PERCEPS_FLAGS)
  AC_SUBST(PERCEPS_ENV)
  AC_SUBST(HAVE_PERCEPS)
  AM_CONDITIONAL(LDAS_COND_HAVE_PERCEPS, test x$PERCEPS != x)
  PERCEPS_STRIP_GENERATING="sed -e 's/^Generating //' -e 's/^\.\/\///'"
  AC_SUBST(PERCEPS_STRIP_GENERATING)
])

dnl======================================================================
dnl AC_LDAS_PROG_PERCEPS
dnl   Check on how to setup perceps
dnl======================================================================

AC_DEFUN([AC_LDAS_PROG_PERCEPS],
[ AC_PATH_PROG(PERCEPS, perceps)
  PERCEPS_FLAGS="-abhmr"
  if test -d ${srcdir}/${ldas_top}/lib/perceps
  then
    PERCEPS_ENV='[$][(]ldas_top_srcdir[)]/lib/perceps'
  elif test -d ${prefix}/lib/perceps
  then
    PERCEPS_ENV="${prefix}/lib/perceps"
  else
    PERCEPS_ENV=""
  fi
  if test -z "${PERCEPS}" \
	|| test -d "${PERCEPS}" || test ! -x "${PERCEPS}" \
	|| test -z "${PERCEPS_ENV}"
  then
    dnl =============================================================
    dnl  Reset variables to be empty since there is no perceps.
    dnl =============================================================
    PERCEPS="";
    PERCEPS_FLAGS=""
    PERCEPS_ENV=""
    HAVE_PERCEPS="no"
  else
    HAVE_PERCEPS="yes"
    PERCEPS_FLAGS=""
  fi
  AC_SUBST(PERCEPS_FLAGS)
  AC_SUBST(PERCEPS_ENV)
  AC_SUBST(HAVE_PERCEPS)
  AM_CONDITIONAL(HAVE_PERCEPS, test x$PERCEPS != x)
  PERCEPS_STRIP_GENERATING="sed -e 's/^Generating //' -e 's/^\.\/\//'"
  AC_SUBST(PERCEPS_STRIP_GENERATING)
])

dnl======================================================================
dnl LDAS_PROG_SWIG
dnl   Check on how to setup swig
dnl======================================================================

AC_DEFUN([LDAS_PROG_SWIG],
[ AC_PATH_PROG( SWIG, swig )
  case "`$SWIG -swiglib`" in
  *swig_lib) ;;
  *) SWIGFLAGS="$SWIGFLAGS -DSWIGNEW";;
  esac
  AC_SUBST(SWIGFLAGS)
  AC_SUBST(SWIG)
])

dnl======================================================================
dnl LDAS_PROG_VALGRIND
dnl======================================================================
AC_DEFUN([LDAS_PROG_VALGRIND],
[ AC_PATH_PROGS( VALGRIND, valgrind )
  AM_CONDITIONAL(HAVE_VALGRIND, test x$VALGRIND != x)
])

